import asyncio
import base64
import re
from datetime import datetime
import urllib.parse

proxies = [
    "http://modeler_pXwAPs:h5BSTf5BA5xg@172.233.49.150:10775",
    "http://modeler_AYKeSi:2YgggYmOCmko@172.233.49.150:10776",
    "http://modeler_MxR92I:1Ezql3MaGQAy@45.86.163.132:11503",
    "http://modeler_wkA8G4:ZMCKQq86TaKG@45.86.163.132:11504",
    "http://modeler_4h2vw9:kKlIqwrMcAHy@45.86.163.132:11505",
    "http://modeler_Xi0v2r:8VYx4bGSDL8f@45.86.163.132:11506",
    "http://modeler_9E7gFb:LsG8DOxmTSXI@62.109.29.75:16651",
    "http://modeler_0vL0aF:VGgNxpQG9XTQ@62.109.29.75:16652",
    "http://modeler_BbHPhN:7GQZlRyAF7GF@62.109.29.75:16653",
    "http://modeler_C8gkqn:V7aFDgF00X5n@62.109.29.75:16654"
]

TARGET_HOST = "172.65.110.202"
TARGET_PORT = 25565

def parse_proxy(proxy_url):
    p = urllib.parse.urlparse(proxy_url)
    return p.hostname, p.port, p.username, p.password

async def create_tunnel(proxy_host, proxy_port, proxy_user, proxy_pass, target_host, target_port):
    reader, writer = await asyncio.open_connection(proxy_host, proxy_port)
    connect_str = f"CONNECT {target_host}:{target_port} HTTP/1.1\r\nHost: {target_host}:{target_port}\r\n"
    if proxy_user and proxy_pass:
        creds = f"{proxy_user}:{proxy_pass}"
        creds_encoded = base64.b64encode(creds.encode()).decode()
        connect_str += f"Proxy-Authorization: Basic {creds_encoded}\r\n"
    connect_str += "\r\n"
    writer.write(connect_str.encode())
    await writer.drain()

    response = await reader.readuntil(b"\r\n\r\n")
    if b"200" not in response.split(b"\r\n")[0]:
        writer.close()
        await writer.wait_closed()
        raise Exception(f"Proxy tunnel failed: {response.decode(errors='ignore')}")
    return reader, writer

async def read_until(reader, suffix=b"= ?", timeout=3):
    buffer = b""
    try:
        while not buffer.endswith(suffix):
            chunk = await asyncio.wait_for(reader.read(1), timeout)
            if not chunk:
                break
            buffer += chunk
    except asyncio.TimeoutError:
        pass
    return buffer

def solve_captcha(captcha_text):
    try:
        text = captcha_text.decode('utf-8')
    except:
        return None
    match = re.search(r'(\d+)\s*\+\s*(\d+)\s*=\s*\?', text)
    if match:
        num1, num2 = int(match.group(1)), int(match.group(2))
        if 1 <= num1 <= 10 and 1 <= num2 <= 10 and (num1 + num2) <= 20:
            return str(num1 + num2)
    return None

async def make_request(proxy_url, attempt_id):
    proxy_host, proxy_port, proxy_user, proxy_pass = parse_proxy(proxy_url)
    try:
        reader, writer = await create_tunnel(proxy_host, proxy_port, proxy_user, proxy_pass, TARGET_HOST, TARGET_PORT)
        captcha_text = await read_until(reader, b"= ?", timeout=2)
        answer = solve_captcha(captcha_text)
        if not answer:
            print(f"[{datetime.now().strftime('%H:%M:%S')}] Proxy {proxy_host}:{proxy_port} Attempt {attempt_id}: Не удалось решить CAPTCHA")
            writer.close()
            await writer.wait_closed()
            return
        writer.write((answer + "\n").encode())
        await writer.drain()
        response = await asyncio.wait_for(reader.read(100), timeout=2)
        print(f"[{datetime.now().strftime('%H:%M:%S')}] Proxy {proxy_host}:{proxy_port} Attempt {attempt_id}: Ответ сервера: {response.decode(errors='ignore').strip()}")
        writer.close()
        await writer.wait_closed()
    except Exception as e:
        print(f"[{datetime.now().strftime('%H:%M:%S')}] Proxy {proxy_host}:{proxy_port} Attempt {attempt_id}: Ошибка: {e}")

async def worker(proxy_url, worker_id):
    attempt_id = 0
    while True:
        await make_request(proxy_url, f"{worker_id}-{attempt_id}")
        attempt_id += 1
        # без задержки

async def main():
    tasks = []
    for proxy in proxies:
        for i in range(10):  # 10 потоков на прокси
            tasks.append(asyncio.create_task(worker(proxy, i)))
    await asyncio.gather(*tasks)

if __name__ == "__main__":
    asyncio.run(main())
