import multiprocessing
import socket
import base64
import re
import urllib.parse
from datetime import datetime

proxies = [
    "http://modeler_pXwAPs:h5BSTf5BA5xg@172.233.49.150:10775",
    "http://modeler_AYKeSi:2YgggYmOCmko@172.233.49.150:10776",
    "http://modeler_MxR92I:1Ezql3MaGQAy@45.86.163.132:11503",
    "http://modeler_wkA8G4:ZMCKQq86TaKG@45.86.163.132:11504",
    "http://modeler_4h2vw9:kKlIqwrMcAHy@45.86.163.132:11505",
    "http://modeler_Xi0v2r:8VYx4bGSDL8f@45.86.163.132:11506",
    "http://modeler_9E7gFb:LsG8DOxmTSXI@62.109.29.75:16651",
    "http://modeler_0vL0aF:VGgNxpQG9XTQ@62.109.29.75:16652",
    "http://modeler_BbHPhN:7GQZlRyAF7GF@62.109.29.75:16653",
    "http://modeler_C8gkqn:V7aFDgF00X5n@62.109.29.75:16654"
]

TARGET_HOST = "172.65.110.202"
TARGET_PORT = 25565

def parse_proxy(proxy_url):
    p = urllib.parse.urlparse(proxy_url)
    return p.hostname, p.port, p.username, p.password

def solve_captcha(captcha_text):
    try:
        text = captcha_text.decode('utf-8')
    except:
        return None
    match = re.search(r'(\d+)\s*\+\s*(\d+)\s*=\s*\?', text)
    if match:
        num1, num2 = int(match.group(1)), int(match.group(2))
        if 1 <= num1 <= 10 and 1 <= num2 <= 10 and (num1 + num2) <= 20:
            return str(num1 + num2)
    return None

def create_tunnel(sock, proxy_host, proxy_port, proxy_user, proxy_pass, target_host, target_port):
    connect_str = f"CONNECT {target_host}:{target_port} HTTP/1.1\r\nHost: {target_host}:{target_port}\r\n"
    if proxy_user and proxy_pass:
        creds = f"{proxy_user}:{proxy_pass}"
        creds_encoded = base64.b64encode(creds.encode()).decode()
        connect_str += f"Proxy-Authorization: Basic {creds_encoded}\r\n"
    connect_str += "\r\n"
    sock.sendall(connect_str.encode())

    response = b""
    while b"\r\n\r\n" not in response:
        response += sock.recv(4096)
    if b"200" not in response.split(b"\r\n")[0]:
        raise Exception(f"Proxy tunnel failed: {response.decode(errors='ignore')}")

def communicate(proxy_url, worker_id):
    proxy_host, proxy_port, proxy_user, proxy_pass = parse_proxy(proxy_url)
    while True:
        try:
            sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            sock.settimeout(5)
            sock.connect((proxy_host, proxy_port))
            create_tunnel(sock, proxy_host, proxy_port, proxy_user, proxy_pass, TARGET_HOST, TARGET_PORT)
            
            # Читаем до CAPTCHA
            data = b""
            while not data.endswith(b"= ?"):
                chunk = sock.recv(1)
                if not chunk:
                    break
                data += chunk

            answer = solve_captcha(data)
            if not answer:
                print(f"[{datetime.now().strftime('%H:%M:%S')}] Proxy {proxy_host}:{proxy_port} Worker {worker_id}: Не удалось решить CAPTCHA")
                sock.close()
                continue

            sock.sendall((answer + "\n").encode())

            # Читаем ответ сервера (первые 100 байт)
            response = sock.recv(100)
            print(f"[{datetime.now().strftime('%H:%M:%S')}] Proxy {proxy_host}:{proxy_port} Worker {worker_id}: Ответ: {response.decode(errors='ignore').strip()}")

            sock.close()

        except Exception as e:
            print(f"[{datetime.now().strftime('%H:%M:%S')}] Proxy {proxy_host}:{proxy_port} Worker {worker_id}: Ошибка: {e}")

def start_workers_for_proxy(proxy_url):
    workers = []
    for i in range(10):  # 10 потоков на прокси
        p = multiprocessing.Process(target=communicate, args=(proxy_url, i))
        p.start()
        workers.append(p)
    for w in workers:
        w.join()

if __name__ == "__main__":
    processes = []
    for proxy in proxies:
        p = multiprocessing.Process(target=start_workers_for_proxy, args=(proxy,))
        p.start()
        processes.append(p)
    for proc in processes:
        proc.join()
